<?php

/**
 * i-doit APi
 *
 * @package i-doit
 * @subpackage API
 * @author Dennis Stücken <dstuecken@synetics.de>
 * @copyright synetics GmbH
 * @license http://www.i-doit.com/license
 */
class isys_api_model_shd_cancel implements isys_api_model_interface
{

    protected $m_cache_object = null;

    function __construct()
    {
        try {
            $this->m_cache_object = new isys_cache_smview_memcached();
            // this namespace is also use by isys_api_model_shd_object.class.php
            $this->m_cache_object->ns('object_cancel');
        } catch (isys_exception $ex) {
        }
    }

    /**
     * Read Map
     *
     * @param array $p_params
     *     array (
     *         'map_id'       =>      'integer',
     *     )
     * @return array|string
     */
    public function read($p_params)
    {
        try {
            if (isset($p_params["request_id"]) == false) {
                throw new isys_exception_api('Parameter request_id missed', -32602);
            }

            $processCancelArray = $this->m_cache_object->get("process_cancel");
            $processCancelArray[] = $p_params["request_id"];

            $this->m_cache_object->set("process_cancel", $processCancelArray, 60);
            return $this->m_cache_object->get("process_cancel");
        } catch (isys_exception $ex) {
            return $ex->getMessage();
        }
    }
}
