<?php

/**
 * SHD API
 *
 * @package shd
 * @subpackage API
 * @author Maik Rhode <Maik.Rhode@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 */
class isys_api_model_shd_dialog implements isys_api_model_interface
{

    /**
     * @param  array $p_params
     * @return array
     * @throws isys_exception_api
     * @throws isys_exception_auth
     * @throws isys_exception_database
     */
    public function read($p_params)
    {
        $isys_api_model_cmdb_dialog = new isys_api_model_cmdb_dialog(new isys_cmdb_dao(isys_application::instance()->database));
        if (isset($p_params["category"])) {
            $l_category = $p_params["category"];
        } else {
            throw new isys_exception_api("Parameter category is missing.");
        }

        if (isset($p_params["property"])) {
            $l_property = $p_params["property"];
        } else {
            throw new isys_exception_api("Parameter property is missing.");
        }

        if (isset($p_params["parent_id"])) {
            $l_parent_id = $p_params["parent_id"];
        }

        if (isset($p_params["parent_title"])) {
            $l_parent_title = $p_params["parent_title"];
        }

        $array = ["category" => $l_category, "property" => $l_property];

        $l_dialog = $isys_api_model_cmdb_dialog->read($array);
        $l_return = [];
        foreach ($l_dialog as $item) {
            if (isset($item["parent"])) {
                if (isset($l_parent_id) && $item["parent"]["id"] !== $l_parent_id) {
                    continue;
                }

                if (isset($l_parent_title) && $item["parent"]["title"] !== $l_parent_title) {
                    continue;
                }
            }
            $l_return[] = ["id" => $item["id"], "title" => $item["title"], "const" => $item["const"] ];
        }
        return $l_return;
    }

    /**
     * @param  $p_params
     * @return array
     * @throws Exception
     */
    public function section($p_params)
    {
        global $g_comp_database;
        $l_query_dao = new smview_cmdb_dao_cable($g_comp_database);
        return $l_query_dao->section($p_params);
    }
}
