<?php

/**
 * shd.api.map_object
 *
 * @package SHD
 * @subpackage API
 * @author Maik Rhode <Maik.Rhode@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 */

class isys_api_model_shd_info implements isys_api_model_interface
{

    /**
     * @param array $p_params
     * @return array
     */
    public function read($p_params)
    {
        $return = [];
        $string = file_get_contents(realpath(__DIR__ . "/../../../package.json"));
        $json_smview_version = json_decode($string, true);
        $version = $json_smview_version["version"];
        $parts = explode('.', $version);
        if (! empty($parts)) {
            $majorVersion = (int) $parts[0];
            if ($majorVersion >= 2023) {
                // fake current version to be compatible with older sm-view clients
                $buildVersion = array_pop($parts);
                $version = '1.5.' . $buildVersion;
            }
        }
        $return["api_version"] = $version;
        return $return;
    }
}
