<?php

/**
 * i-doit APi
 *
 * @package i-doit
 * @subpackage API
 * @author Dennis Stücken <dstuecken@synetics.de>
 * @copyright synetics GmbH
 * @license http://www.i-doit.com/license
 */
class isys_api_model_shd_map_favorites implements isys_api_model_interface
{

    /**
     * Read map favorites.
     *
     * @param  array $p_params
     * @return array
     */
    public function read($p_params)
    {
        try {
            $l_homemap = smview_cmdb_dao_map::instance(isys_application::instance()->database)->getFavorites($p_params["user_id"]);
            return $l_homemap;
        } catch (Exception $ex) {
            return array(
                'message'      => 'map_favorites.read.error',
                'response'     => $ex->getMessage(),
                'current_date' => date('Y-m-d')
            );
        }
    }

    /**
     * Create map favorite.
     *
     * @param  array $p_params
     * @return array
     * @throws isys_exception_dao
     */
    public function create($p_params)
    {
        smview_cmdb_dao_map::instance(isys_application::instance()->database)->createMapFavorites($p_params["user_id"], $p_params["parent_id"], $p_params["title"]);
        return array(
            'message'      => 'map_favoriten.create.success',
            'current_date' => date('Y-m-d')
        );
    }
}
