<?php

/**
 * SHD APi
 *
 * @package SHD
 * @subpackage API
 */
class isys_api_model_shd_map_home implements isys_api_model_interface
{
    /**
     * @param array $p_params
     * @return array
     */
    public function read($p_params)
    {
        try {
            $l_homemap = smview_cmdb_dao_map::instance(isys_application::instance()->database)->getHome($p_params["user_id"]);
            return $l_homemap;
        } catch (Exception $ex) {
            return array(
                'message'      => 'map_home.read.error',
                'response'     => $ex->getMessage(),
                'current_date' => date('Y-m-d')
            );
        }
    }

    /**
     * @param  $p_params
     * @return array
     * @throws Exception
     */
    public function update($p_params)
    {
        smview_cmdb_dao_map::instance(isys_application::instance()->database)->deleteHome($p_params["user_id"]);
        smview_cmdb_dao_map::instance(isys_application::instance()->database)->addHome($p_params["user_id"], $p_params["map_id"]);
        return array(
            'message'      => 'map_home.update.success',
            'response'     => true,
            'current_date' => date('Y-m-d')
        );
    }
}
