<?php

/**
 * i-doit APi
 *
 * @package i-doit
 * @subpackage API
 * @author Dennis Stücken <dstuecken@synetics.de>
 * @copyright synetics GmbH
 * @license http://www.i-doit.com/license
 */
class isys_api_model_shd_map_right implements isys_api_model_interface
{

    /**
     * @param array $p_params
     * @return array
     */
    public function read($p_params)
    {
        try {
            return smview_cmdb_dao_map::instance(isys_application::instance()->database)->getMapRight($p_params["mapright_id"]);
        } catch (Exception $ex) {
            return array(
                'message'      => 'map_right.read.error',
                'response'     => $ex->getMessage(),
                'current_date' => date('Y-m-d')
            );
        }
    }

    /**
     * @param array $p_params
     * @return array
     */
    public function readAll($p_params)
    {
        try {
            if (isset($p_params["map_id"])) {
                $l_maprights = smview_cmdb_dao_map::instance(isys_application::instance()->database)->getAllMapRightByMapId($p_params["map_id"]);
            } else {
                $l_maprights = smview_cmdb_dao_map::instance(isys_application::instance()->database)->getAllMapRight();
            }
            return $l_maprights;
        } catch (Exception $ex) {
            return array(
                'message'      => 'map_right.readAll.error',
                'response'     => $ex->getMessage(),
                'current_date' => date('Y-m-d')
            );
        }
    }

    /**
     * @param array $p_params
     * @return array
     */
    public function create($p_params)
    {
        $l_return_id = smview_cmdb_dao_map::instance(isys_application::instance()->database)->createMapRight($p_params);
        return array(
            'message'      => 'map_right.create.success',
            'response'     => $l_return_id,
            'current_date' => date('Y-m-d')
        );
    }

    /**
     * @param array $p_params
     * @return array
     */
    public function update($p_params)
    {
        smview_cmdb_dao_map::instance(isys_application::instance()->database)->updateMapRight($p_params);
        return array(
            'message'      => 'map_right.update.success',
            'response'     => true,
            'current_date' => date('Y-m-d')
        );
    }

    /**
     * @param array $p_params
     * @return array
     */
    public function delete($p_params)
    {
        smview_cmdb_dao_map::instance(isys_application::instance()->database)->deleteMapRight($p_params["mapright_id"]);
        return array(
            'message'      => 'map_right.delete.success',
            'response'     => true,
            'current_date' => date('Y-m-d')
        );
    }
}
