<?php

/**
 * shd API Insights
 *
 * @package shd
 * @subpackage API
 * @author Maik Rhode <maik.rhode@shd-online.de>
 */
class isys_api_model_shd_monitoring implements isys_api_model_interface
{

    /**
     * Read Insights Entry
     *
     * @param array $p_params
     * @return array
     */
    public function read($p_params)
    {
        return false;
    }

    public function readExportConfig($p_params)
    {
        $l_export_config     = [];
        $l_export_config_res = isys_monitoring_dao_hosts::instance(isys_application::instance()->database)
            ->get_export_data($p_params['export_config_id']);
        if (count($l_export_config_res)) {
            while ($l_row = $l_export_config_res->get_row()) {
                $l_export_config[] = $l_row;
            }
        }
        return $l_export_config;
    }

    public function readExportConfigs()
    {
        $l_export_config     = [];
        $l_export_config_res = isys_monitoring_dao_hosts::instance(isys_application::instance()->database)
            ->get_export_data();
        if (count($l_export_config_res)) {
            while ($l_row = $l_export_config_res->get_row()) {
                $l_export_config[] = $l_row;
            }
        }
        return $l_export_config;
    }

    public function createExportConfig($p_params)
    {
        $l_return_id = isys_monitoring_dao_hosts::instance(isys_application::instance()->database)
            ->save_export_config(null, $p_params['export_config']);
        return array(
            'message'      => 'monitoring.createExportConfigs.success',
            'response'     => $l_return_id,
            'current_date' => date('Y-m-d')
        );
    }

    public function updateExportConfig($p_params)
    {
        $l_return_id = isys_monitoring_dao_hosts::instance(isys_application::instance()->database)
            ->save_export_config($p_params['export_config_id'], $p_params['export_config']);
        return array(
            'message'      => 'monitoring.updateExportConfigs.success',
            'response'     => $l_return_id,
            'current_date' => date('Y-m-d')
        );
    }

    public function deleteExportConfig($p_params)
    {
        $l_return_id = isys_monitoring_dao_hosts::instance(isys_application::instance()->database)
            ->delete_export_config($p_params['export_config_id']);
        return array(
            'message'      => 'monitoring.deleteExportConfigs.success',
            'response'     => $l_return_id,
            'current_date' => date('Y-m-d')
        );
    }

    public function readLivestatus($p_params)
    {
        $l_export_config     = [];
        $l_export_config_res = isys_monitoring_dao_hosts::instance(isys_application::instance()->database)
            ->get_data($p_params['livestatus_id']);
        if (count($l_export_config_res)) {
            while ($l_row = $l_export_config_res->get_row()) {
                $l_export_config[] = $l_row;
            }
        }
        return $l_export_config;
    }

    public function readAllLivestatus()
    {
        $l_export_config     = [];
        $l_export_config_res = isys_monitoring_dao_hosts::instance(isys_application::instance()->database)->get_data();
        if (count($l_export_config_res)) {
            while ($l_row = $l_export_config_res->get_row()) {
                $l_export_config[] = $l_row;
            }
        }
        return $l_export_config;
    }

    public function createLivestatus($p_params)
    {
        $l_config = $p_params["livestatus"];
        $l_config['password'] =  isys_helper_crypt::encrypt($l_config['password']);

        $l_return_id = isys_monitoring_dao_hosts::instance(isys_application::instance()->database)
            ->save(null, $l_config);
        return array(
            'message'      => 'monitoring.createLivestatus.success',
            'response'     => $l_return_id,
            'current_date' => date('Y-m-d')
        );
    }

    public function updateLivestatus($p_params)
    {
        $l_config = $p_params["livestatus"];
        $l_config['password'] =  isys_helper_crypt::encrypt($l_config['password']);
        $p_config_id = $l_config['livestatus_id'];
        unset($l_config['livestatus_id']);

        $l_return_id = isys_monitoring_dao_hosts::instance(isys_application::instance()->database)
            ->save($p_config_id, $l_config);
        return array(
            'message'      => 'monitoring.updateLivestatus.success',
            'response'     => $l_return_id,
            'current_date' => date('Y-m-d')
        );
    }

    public function deleteLivestatus($p_params)
    {
        $l_return_id = isys_monitoring_dao_hosts::instance(isys_application::instance()->database)
            ->delete($p_params['livestatus_id']);
        return array(
            'message'      => 'monitoring.deleteLivestatus.success',
            'response'     => $l_return_id,
            'current_date' => date('Y-m-d')
        );
    }
}
