<?php

/**
 * i-doit APi
 *
 * @package i-doit
 * @subpackage API
 * @author Dennis Stücken <dstuecken@synetics.de>
 * @copyright synetics GmbH
 * @license http://www.i-doit.com/license
 */

/*
 *
 * @todo: is this class obsolete?
 *
 */
class isys_api_model_shd_port_template implements isys_api_model_interface
{

    /**
     * Read Map
     *
     * @author Maik Rhode <maik.rhode@shd-online.de>
     * @param array $p_params
     *     array (
     *         'map_id' => 'integer',
     *     )
     * @return array map object
     * @throws isys_exception_api
     */
    public function read($p_params)
    {
        global $g_comp_database;

        if (isset($p_params["obj_id"]) == false) {
            throw new isys_exception_api('Parameter obj_id missed', -32602);
        }

        $l_cable_dao = isys_cmdb_dao_category_g_connector::instance($g_comp_database);
        $l_res = $l_cable_dao->get_data(null, $p_params["obj_id"]);
        $return = [];
        while ($l_row = $l_res->get_row()) {
            $t_row = [];

            $t_row["isys_obj__id"] = $l_row["isys_obj__id"];
            $t_row["isys_obj__title"] = $l_row["isys_obj__title"];
            $t_row["con_connector"] = $l_row["con_connector"];
            $t_row["connector_name"] = $l_row["connector_name"];
            $t_row["isys_catg_connector_list__title"] = $l_row["isys_catg_connector_list__title"];
            $t_row["isys_catg_connector_list__type"] = $l_row["isys_catg_connector_list__type"];
            $t_row["isys_catg_connector_list__isys_obj__id"] = $l_row["isys_catg_connector_list__isys_obj__id"];
            $t_row["isys_catg_connector_list__isys_connection__id"] = $l_row["isys_catg_connector_list__isys_connection__id"];
            $return[] = $l_row;
        }
        return $return;
    }

    /**
     * Create Map Entry
     *
     * @author Maik Rhode <maik.rhode@shd-online.de>
     * @param array $p_params
     *     array (
     *         'title'   => 'name der Map',
     *         'user_id' => 'BenutzerId',
     *     )
     * @return array (
     *         'message'      => 'name der Map',
     *         'response'     => 'BenutzerId',
     *         'current_date' => 'BenutzerId',
     *     )
     */
    public function create($p_params)
    {
        $l_return_id = smview_cmdb_dao_map::instance(isys_application::instance()->database)->createMap($p_params["title"], $p_params["user_id"]);
        return array(
            'message'      => 'map.create.success',
            'response'     => ['map_id' =>$l_return_id],
            'current_date' => date('Y-m-d')
        );
    }

    /**
     * Update Map Entry
     *
     * @author Maik Rhode <maik.rhode@shd-online.de>
     * @return array (
     *         'message'      => 'name der Map',
     *         'response'     => 'BenutzerId',
     *         'current_date' => 'BenutzerId',
     *     )
     */
    public function update()
    {
        return array(
            'message'      => 'map.update.success',
            'response'     => true,
            'current_date' => date('Y-m-d')
        );
    }

    /**
     * Delete Map Entry
     *
     * @author Maik Rhode <maik.rhode@shd-online.de>
     * @param array $p_params
     *     array (
     *         'map_id' => 'Id der Map',
     *     )
     * @return array (
     *         'message'      => 'name der Map',
     *         'response'     => 'BenutzerId',
     *         'current_date' => 'BenutzerId',
     * )
     * @throws isys_exception_api
     */
    public function delete($p_params)
    {
        if (isset($p_params["map_id"]) == false) {
            throw new isys_exception_api('Parameter map_id missed', -32602);
        }

        smview_cmdb_dao_map::instance(isys_application::instance()->database)->deleteMap($p_params["map_id"]);
        return array(
            'message'      => 'map.delete.success',
            'response'     => true,
            'current_date' => date('Y-m-d')
        );
    }
}
