<?php

/**
 * SHD API.
 *
 * @package shd
 * @subpackage API
 * @author Maik Rhode <Maik.Rhode@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 */
class isys_api_model_shd_query implements isys_api_model_interface
{

    /**
     * @param array $p_params
     * @return array
     */
    public function read($p_params)
    {
        global $g_comp_database;
        $l_query_dao = new smview_cmdb_dao_queryfast($g_comp_database);
        return $l_query_dao->read($p_params);
    }

    /**
     * @param $p_params
     * @return array
     */
    public function relation($p_params)
    {
        global $g_comp_database;
        $l_query_dao = new smview_cmdb_dao_query($g_comp_database);
        return $l_query_dao->relation($p_params);
    }

    public function inspector($p_params)
    {
        global $g_comp_database;
        $l_query_dao = new smview_cmdb_dao_queryfast($g_comp_database);
        return $l_query_dao->read($p_params);
    }

    /**
     * @param  array $p_params
     * @return array
     * @throws Exception
     */
    public function category($p_params)
    {
        global $g_comp_database;
        $l_query_dao = new smview_cmdb_dao_query_category($g_comp_database);
        return $l_query_dao->read($p_params);
    }

    /**
     * @param array $p_params
     * @return array
     */
    public function category_wire($p_params)
    {
        global $g_comp_database;
        $isys_cmdb_dao_category_g_smview_cable_section_element = new isys_cmdb_dao_category_g_smview_cable_section_element($g_comp_database);
        return $isys_cmdb_dao_category_g_smview_cable_section_element->add_connection_information(["obj_in_id" => "13488", "cable_id" => "cable_id"]);
    }

    /**
     * @param array $p_params
     * @return array
     */
    public function test_category($p_params)
    {
        $categoryConstant = $p_params["C__CATG__GLOBAL-type"];
        if (empty($categoryConstant)) {
            var_dump("is empty". $categoryConstant);
        }

        if (!is_string($categoryConstant)) {
            var_dump("!is_string" . $categoryConstant);
        }

        if (!defined($categoryConstant)) {
            var_dump("!defined" . $categoryConstant);
        }
        return [];
    }

    public function readfast($p_params)
    {
        global $g_comp_database;
        $l_query_dao = new smview_cmdb_dao_query($g_comp_database);
        return $l_query_dao->readfast($p_params);
    }
}
