<?php

/**
 * SHD API.
 *
 * @package shd
 * @subpackage API
 * @author Maik Rhode <Maik.Rhode@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 */
class isys_api_model_shd_template implements isys_api_model_interface
{

    /**
     * @param  array $p_params
     * @return array
     * @throws Exception
     */
    public function read($p_params)
    {
        //check Userright
        $hasRight = true;

        $l_filter["shd_filter__display_rows"] = $p_params["display_rows"];
        $l_filter["shd_filter__page"] = $p_params["page"];
        $l_filter["shd_filter__display_relations"] = "0";
        $l_filter["shd_filter__empty_values"] = "1";
        $l_filter["shd_filter__status"] = defined_or_default('C__RECORD_STATUS__TEMPLATE');

        $l_filter["shd_filter__columns"] = $p_params["columns"];
        $l_filter["shd_filter__condition"] = $p_params["condition"];

        //Query for not mounted objects
        if (isset($p_params["notMounted"]) && $p_params["notMounted"] == true) {
            $l_filter["shd_filter__columns"][] =  ["id"=>"708", "width" =>"50", "sort" => ""];
            $l_filter["shd_filter__condition"][] =
                ["category" => "C__CATG__LOCATION", "property" => "C__CATG__LOCATION-pos", "comparison" =>"IS NULL", "value" => ""];
        }

        //change the property-const to id
        $properties = smview_cmdb_dao_properties::instance(isys_application::instance()->database)->getProperties(false);
        $t_properties = [];
        foreach ($properties as $property) {
            $t_properties[$property['const'] . '-' . $property['key']] = $property;
        }

        $properties = $t_properties;

        //sort of columns
        foreach ($l_filter['shd_filter__columns'] as $filterKey => $shd_filter__column) {
            $l_filter['shd_filter__columns'][$filterKey]['id'] = $properties[$shd_filter__column['id']]['id'];
            if ($shd_filter__column['sort'] != "") {
                $l_filter['sorting_default'] = $shd_filter__column['id'];
                $l_filter['sorting_direction'] = $shd_filter__column['sort'];
            }
        }

        //Abfrage nach den Ids und anhand der das Paging anwenden
        $l_filter_ids = $l_filter;

        $smview_cmdb_dao_filter_sql = new smview_cmdb_dao_filter_sql(isys_application::instance()->database);
        $query_filter = $smview_cmdb_dao_filter_sql->create_property_query_for_filter($l_filter_ids, false);

        $filter = smview_cmdb_dao_filter::instance(isys_application::instance()->database)->query($query_filter);

        //Check if User has right for Object
        if ($hasRight === false) {
            $filter["num"] = "0";
            $filter["content"] = [];
        }

        $filter["page"] = $l_filter["shd_filter__page"];
        $filter["display_rows"] = $l_filter["shd_filter__display_rows"];
        return $filter;
    }
}
