<?php
/**
 * Class smview_cmdb_dao_action
 */

class smview_cmdb_dao_action extends isys_module_dao
{
    protected static $m_instance = null;

    public function save($p_id, $p_values)
    {
        $l_data = [];
        if ($p_id === null || empty($p_id)) {
            $l_sql = 'INSERT INTO shd_action SET %s;';
        } else {
            $l_sql = 'UPDATE shd_action SET %s WHERE shd_action__id = ' . $this->convert_sql_id($p_id) . ';';
        }

        if (count($p_values) > 0) {
            foreach ($p_values as $l_key => $l_value) {
                $l_data[] = 'shd_action__' . $l_key . ' = ' . $this->convert_sql_text($l_value);
            }
            $this->update(str_replace('%s', implode(', ', $l_data), $l_sql)) && $this->apply_update();
        }
        return $p_id ?: $this->get_last_insert_id();
    }


    /**
     * @param  $action_id
     * @return boolean
     * @throws isys_exception_dao
     */
    public function deleteAction($action_id)
    {
        $this->begin_update();

        /* Delete old dataitems / contact references and main record */
        $l_q   = "DELETE FROM shd_action WHERE shd_action__id = " . $this->convert_sql_id($action_id);
        $l_res = $this->update($l_q);
        if ($l_res) {
            return $this->apply_update();
        }
        return false;
    }

    /**
     * Get data method. Unused.
     *
     * @return  null
     */
    public function get_data()
    {
        return null;
    }

    /**
     * @param  $p_params
     * @return array|bool
     * @throws isys_exception_database
     */
    public function getAction($p_params)
    {
        $l_row = $this->retrieve("SELECT * FROM shd_action WHERE shd_action__id = " . $p_params['action_id'] . ";")->get_row();
        if (empty($l_row)) {
            return false;
        }

        $l_return = [];
        foreach ($l_row as $f_key => $f_item) {
            if ($f_key == "shd_action__id") {
                $l_return["action_id"] = $f_item;
            } else {
                $l_return[str_replace("shd_action__", "", $f_key)] = $f_item;
            }
        }
        return $l_return;
    }

    /**
     * @return array
     * @throws isys_exception_database
     */
    public function getActions()
    {
        $l_res = $this->retrieve("SELECT action.* FROM shd_action AS action");
        while ($l_data = $l_res->get_row()) {
            $l_return = [];
            foreach ($l_data as $f_key => $f_item) {
                if ($f_key == "shd_action__id") {
                    $l_return["action_id"] = $f_item;
                } else {
                    $l_return[str_replace("shd_action__", "", $f_key)] = $f_item;
                }
            }
            $actions[] = $l_return;
        }
        return $actions;
    }
}
