<?php

use idoit\Module\Cable\LocationTracing;

/**
 * i-doit - Documentation and CMDB solution for IT environments
 *
 * This file is part of the i-doit framework. Modify at your own risk.
 *
 * Please visit http://www.i-doit.com/license for a full copyright and license information.
 *
 * @version     1.8.3
 * @package     i-doit
 * @author      synetics GmbH
 * @copyright   synetics GmbH
 * @url         http://www.i-doit.com
 * @license     http://www.i-doit.com/license
 */
class smview_cmdb_dao_cable extends isys_module_dao
{
    protected static $m_instance = null;

    protected $m_db;

    protected $m_properties;

    protected $m_object_type;

    protected $m_table;

    /**
     * Database component.
     *
     * @param isys_component_database $p_db
     * @throws Exception
     */
    public function __construct(isys_component_database $p_db)
    {
        $properties = smview_cmdb_dao_properties::instance(isys_application::instance()->database)->getProperties(false);
        //change the property-const to id
        $t_properties = [];
        foreach ($properties as $property) {
            $t_properties[$property['const'] . '-' . $property['key']] = $property;
        }

        $this->m_properties = $t_properties;
        parent::__construct($p_db);
    }

    /**
     * @param array $p_params
     * @return array
     */
    public function section($p_params)
    {
        $vanilla_columns = $p_params["columns"];
        $tracing = new LocationTracing();
        foreach ($vanilla_columns as $filterKey => $shd_filter__column) {
            $vanilla_columns[$filterKey]['id_property'] = $this->getProperty($shd_filter__column['id'])['id'];
            $vanilla_columns[$filterKey]['i18n_title'] = $this->getProperty($shd_filter__column['id'])["title"];
        }

        $l_return = [];
        $l_return["headers"] = $vanilla_columns;
        if (isset($p_params["condition"])) {
            foreach ($p_params["condition"] as $f_condition) {
                if ($f_condition["property"] == "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT-obj_out_title") {
                    $location_id = $f_condition['value'];
                }
            }
        }

        $l_content = $tracing->get_objects_by_location($location_id);
        foreach ($l_content as $f_content) {
            $l_return["content"][$f_content["id"]]["C__CATG__SMVIEW_CABLE_SECTION_ELEMENT-obj_in_title"] = $location_id;
            $l_return["content"][$f_content["id"]]["C__CATG__SMVIEW_CABLE_SECTION_ELEMENT-obj_out_title"] = $f_content["title"];
            $l_return["content"][$f_content["id"]]["C__CATG__SMVIEW_CABLE_SECTION_ELEMENT-cable_title"] = "";
        }
        return $l_return;
    }

    private function getProperty($key)
    {
        if (is_numeric($key)) {
            //foreach and if for id
            foreach ($this->m_properties as $m_property) {
                if ($m_property["id"] == $key) {
                    return $m_property;
                }
            }
        } else {
            return $this->m_properties[$key];
        }
        return null;
    }

    /**
     * get_data always retrieves the data of the main table of this module
     */
    public function get_data()
    {
        // TODO: Implement get_data() method.
    }
}
