<?php
/**
 * Class smview_cmdb_dao_action
 */

class smview_cmdb_dao_location extends isys_cmdb_dao_category_g_location
{

    /**
     * Formats a location string according to the specified enclosure ID.
     *
     * @param   integer $p_obj_id
     *
     * @return  array
     * @author  Dennis Stücken <dstuecken@i-doit.de>
     */
    public function get_shd_path($p_obj_id)
    {
        $l_return   = [];
        $l_parentid['parent'] = $p_obj_id;
        while (($l_parentid = $this->get_parent_object_by_object($l_parentid['parent'])) !== false) {
            if(in_array($l_parentid, $l_return)) {
                break;
            }
            $l_return[] = $l_parentid;
        }
        return $l_return;
    }

    public function get_shd_path_to_string($p_obj_id, $with_themselves = false)
    {
        $l_return   = [];
        $l_parentid['parent'] = $p_obj_id;
        $f = 0;
        while (($l_parentid = $this->get_parent_object_by_object($l_parentid['parent'])) !== false) {
            if($f > 20){
                return "SCHLEIFE" ;
            }
            $f++;

            $l_return[] = $l_parentid;
        }

        $l_returnstring = "";
        if (count($l_return) <= 1) {
            return "";
        }

        $f_from_count = count($l_return) - 1;
        if ($with_themselves === true) {
            $f_to_count = 0;
        } else {
            $f_to_count = 1;
        }

        for ($i = $f_from_count; $i >= $f_to_count; $i--) {
            if ($l_return[$i]['value'] == "Root location") {
                $l_return[$i]['value'] = "Root";
            }
            $l_returnstring .= $l_return[$i]['value'] . " > ";
        }

        if (strlen($l_returnstring) > 2) {
            $l_returnstring = substr($l_returnstring, 0, -3);
        }
        return $l_returnstring;
    }

    public function get_parent_object_by_object($p_obj_id)
    {
        if ($p_obj_id <= 0) {
            return false;
        }

        if (! isset(self::$m_location_cache[$p_obj_id])) {
            $l_sql = 'SELECT isys_catg_location_list__parentid AS parent, isys_obj__title AS title
                FROM isys_obj LEFT JOIN isys_catg_location_list ON isys_catg_location_list__isys_obj__id = isys_obj__id
                WHERE isys_obj__id = ' . $this->convert_sql_id($p_obj_id) . ';';

            $l_parent = $this->retrieve($l_sql)->get_row();
            self::$m_location_cache[$p_obj_id] = [
                'value'  => $l_parent['title'],
                '__id__' => $p_obj_id,
                'parent' => $l_parent['parent'] ?: false
            ];
        }
        return self::$m_location_cache[$p_obj_id];
    }

    public function get_list()
    {
        $l_sql = 'SELECT * FROM isys_catg_location_list INNER JOIN isys_obj ON isys_catg_location_list__isys_obj__id = isys_obj__id;';
        $l_parent = $this->retrieve($l_sql);
        $return = [];
        while ($l_data = $l_parent->get_row()) {
            $return[] = $l_data;
        }
        return $return;
    }

    public function get_relation_list()
    {
        $l_sql = "
            SELECT
            relation_type.isys_relation_type__id as 'relation_type.isys_relation_type__id',
            relation_type.isys_relation_type__title as 'relation_type.isys_relation_type__title',
            
            relation.isys_obj__id as 'relation.isys_obj__id',
            relation.isys_obj__title as 'relation.isys_obj__title',
            
            master.isys_obj__id as 'master.isys_obj__id',
            master.isys_obj__title as 'master.isys_obj__title',
            master.isys_obj__description as 'master.isys_obj__description',
            master.isys_obj__isys_cmdb_status__id as 'master.isys_obj__isys_cmdb_status__id',
            
            master.isys_obj__created as 'master.isys_obj__created',
            master.isys_obj__created_by as 'master.isys_obj__created_by',
			master.isys_obj__updated as 'master.isys_obj__updated',
			master.isys_obj__updated_by as 'master.isys_obj__updated_by',
			
            master.isys_obj__sysid as 'master.isys_obj__sysid',
			master.isys_obj__status as 'master.isys_obj__status',
            
            master_type.isys_obj_type__id as 'master_type.isys_obj_type__id',
			master_type.isys_obj_type__title as 'master_type.isys_obj_type__title',

			
            slave.isys_obj__id as 'slave.isys_obj__id',
            slave.isys_obj__title as 'slave.isys_obj__title',
            slave.isys_obj__description as 'slave.isys_obj__description',
            slave.isys_obj__isys_cmdb_status__id as 'slave.isys_obj__isys_cmdb_status__id',
            
            slave.isys_obj__created as 'slave.isys_obj__created',
            slave.isys_obj__created_by as 'slave.isys_obj__created_by',
			slave.isys_obj__updated as 'slave.isys_obj__updated',
			slave.isys_obj__updated_by as 'slave.isys_obj__updated_by',
			
            slave.isys_obj__sysid as 'slave.isys_obj__sysid',
			slave.isys_obj__status as 'slave.isys_obj__status',
            
            
			slave_type.isys_obj_type__id as 'slave_type.isys_obj_type__id',
			slave_type.isys_obj_type__title as 'slave_type.isys_obj_type__title'
            
             FROM `isys_catg_relation_list`
            Left Join isys_relation_type as relation_type ON  `isys_catg_relation_list__isys_relation_type__id`= relation_type.isys_relation_type__id
            Left Join isys_obj as relation ON  `isys_catg_relation_list__isys_obj__id`= relation.isys_obj__id
            Left Join isys_obj as master ON  `isys_catg_relation_list__isys_obj__id__master`= master.isys_obj__id
			Left Join isys_obj_type as master_type ON  master_type.isys_obj_type__id = master.isys_obj__isys_obj_type__id
            Left Join isys_obj as slave ON  `isys_catg_relation_list__isys_obj__id__slave`= slave.isys_obj__id
			Left Join isys_obj_type as slave_type ON  slave_type.isys_obj_type__id = slave.isys_obj__isys_obj_type__id";

        $l_parent = $this->retrieve($l_sql);
        $return = [];
        while ($l_data = $l_parent->get_row()) {
            $return[] = $l_data;
        }
        return $return;
    }
}
