<?php
/**
 * i-doit - Documentation and CMDB solution for IT environments
 *
 * This file is part of the i-doit framework. Modify at your own risk.
 *
 * Please visit http://www.i-doit.com/license for a full copyright and license information.
 *
 * @version     1.8.3
 * @package     i-doit
 * @author      synetics GmbH
 * @copyright   synetics GmbH
 * @url         http://www.i-doit.com
 * @license     http://www.i-doit.com/license
 */

/**
 * i-doit
 *
 * Template Module Dao.
 *
 * @package     i-doit   Test
 * @subpackage  Modules
 * @author      Dennis Stücken <dstuecken@i-doit.org>
 * @version     0.9
 * @copyright   synetics GmbH
 * @license     http://www.i-doit.com/license
 */

class smview_cmdb_dao_properties extends isys_module_dao
{
    protected static $m_instance = null;

    private $m_validation = null;

    /**
     * @param  boolean $withDialog
     * @param  boolean $withInfo
     * @param  string|null $objectTypeConst
     * @param  int $status
     * @return array
     * @throws Exception
     */
    public function getProperties($withDialog = false, $withInfo = false, $objectTypeConst = null, $status = C__RECORD_STATUS__NORMAL)
    {
        /*
         * special columns
         * "special_column" => "true"
         * "search_disable" => "true"
         * "readonly" => "true"
         *
         */

        $blacklist_json = '{"C__CATG__GLOBAL-status":["C__CATG__GLOBAL-status"],"C__CATG__GLOBAL-_created":["C__CATG__GLOBAL-_created"],"C__CATG__GLOBAL-_changed":["C__CATG__GLOBAL-_changed"],"C__CATG__GLOBAL-_tag":["C__CATG__GLOBAL-_tag"],"C__CATG__CPU-_frequency":["C__CATG__CPU-_frequency"],"C__CATG__CPU-_total_cores":["C__CATG__CPU-_total_cores"],"C__CATG__CPU-_total_cpus":["C__CATG__CPU-_total_cpus"],"C__CATG__MEMORY-_total_capacity":["C__CATG__MEMORY-_total_capacity"],"C__CATG__MEMORY-_capacity":["C__CATG__MEMORY-_capacity"],"C__CATG__APPLICATION-assigned_license_key":["C__CATG__APPLICATION-assigned_license_key"],"C__CATG__APPLICATION-assigned_databases":["C__CATG__APPLICATION-assigned_databases"],"C__CATG__APPLICATION-_variant":["C__CATG__APPLICATION-_variant"],"C__CATG__APPLICATION-_assigned_license_key":["C__CATG__APPLICATION-_assigned_license_key"],"C__CATG__APPLICATION-_assigned_database_schema":["C__CATG__APPLICATION-_assigned_database_schema"],"C__CATG__ACCESS-_primary_url":["C__CATG__ACCESS-_primary_url"],"C__CATG__ACCESS-_url":["C__CATG__ACCESS-_url"],"C__CATG__CONTACT-_person":["C__CATG__CONTACT-_person"],"C__CATG__CONTACT-_linked_person":["C__CATG__CONTACT-_linked_person"],"C__CATG__LOGBOOK-_title":["C__CATG__LOGBOOK-_title"],"C__CATG__LOCATION-_location":["C__CATG__LOCATION-_location"],"C__CATG__LOCATION-_location_path":["C__CATG__LOCATION-_location_path"],"C__CATG__LOCATION-_location_path_raw":["C__CATG__LOCATION-_location_path_raw"],"C__CATG__LOCATION-_pos":["C__CATG__LOCATION-_pos"],"C__CATG__GRAPHIC-_memory":["C__CATG__GRAPHIC-_memory"],"C__CATG__VIRTUAL_MACHINE-virtual_machine":["C__CATG__VIRTUAL_MACHINE-virtual_machine"],"C__CATG__VIRTUAL_MACHINE-_primary":["C__CATG__VIRTUAL_MACHINE-_primary"],"C__CATG__ACCOUNTING-_price":["C__CATG__ACCOUNTING-_price"],"C__CATG__ACCOUNTING-_operation_expense":["C__CATG__ACCOUNTING-_operation_expense"],"C__CATG__ACCOUNTING-_contact":["C__CATG__ACCOUNTING-_contact"],"C__CATG__ACCOUNTING-_guarantee_date":["C__CATG__ACCOUNTING-_guarantee_date"],"C__CATG__NETWORK_PORT-addresses":["C__CATG__NETWORK_PORT-addresses"],"C__CATG__NETWORK_PORT-default_vlan":["C__CATG__NETWORK_PORT-default_vlan"],"C__CATG__NETWORK_PORT-_layer2_assignment":["C__CATG__NETWORK_PORT-_layer2_assignment"],"C__CATG__NETWORK_LOG_PORT-ports":["C__CATG__NETWORK_LOG_PORT-ports"],"C__CATG__NETWORK_LOG_PORT-parent":["C__CATG__NETWORK_LOG_PORT-parent"],"C__CATG__NETWORK_LOG_PORT-_ports":["C__CATG__NETWORK_LOG_PORT-_ports"],"C__CATG__NETWORK_LOG_PORT-_addresses":["C__CATG__NETWORK_LOG_PORT-_addresses"],"C__CATG__NETWORK_LOG_PORT-_layer2_assignment":["C__CATG__NETWORK_LOG_PORT-_layer2_assignment"],"C__CATG__NETWORK_LOG_PORT-_parent":["C__CATG__NETWORK_LOG_PORT-_parent"],"C__CATG__DRIVE-_capacity":["C__CATG__DRIVE-_capacity"],"C__CATG__DRIVE-_free_space":["C__CATG__DRIVE-_free_space"],"C__CATG__DRIVE-_used_space":["C__CATG__DRIVE-_used_space"],"C__CATG__DRIVE-_on_device":["C__CATG__DRIVE-_on_device"],"C__CATG__STORAGE_DEVICE-_total_capacity_hard_disk":["C__CATG__STORAGE_DEVICE-_total_capacity_hard_disk"],"C__CATG__STORAGE_DEVICE-_total_capacity_floppy":["C__CATG__STORAGE_DEVICE-_total_capacity_floppy"],"C__CATG__STORAGE_DEVICE-_total_capacity_cd_rom":["C__CATG__STORAGE_DEVICE-_total_capacity_cd_rom"],"C__CATG__STORAGE_DEVICE-_total_capacity_tape":["C__CATG__STORAGE_DEVICE-_total_capacity_tape"],"C__CATG__STORAGE_DEVICE-_total_capacity_stick":["C__CATG__STORAGE_DEVICE-_total_capacity_stick"],"C__CATG__STORAGE_DEVICE-_total_capacity_ssd":["C__CATG__STORAGE_DEVICE-_total_capacity_ssd"],"C__CATG__STORAGE_DEVICE-_total_capacity_sd_card":["C__CATG__STORAGE_DEVICE-_total_capacity_sd_card"],"C__CATG__STORAGE_DEVICE-_total_capacity_streamer":["C__CATG__STORAGE_DEVICE-_total_capacity_streamer"],"C__CATG__STORAGE_DEVICE-_capacity":["C__CATG__STORAGE_DEVICE-_capacity"],"C__CATG__IP-zone":["C__CATG__IP-zone"],"C__CATG__IP-dns_server":["C__CATG__IP-dns_server"],"C__CATG__IP-dns_server_address":["C__CATG__IP-dns_server_address"],"C__CATG__IP-dns_domain":["C__CATG__IP-dns_domain"],"C__CATG__IP-aliases":["C__CATG__IP-aliases"],"C__CATG__IP-_primary_ip":["C__CATG__IP-_primary_ip"],"C__CATG__IP-_primary_hostname":["C__CATG__IP-_primary_hostname"],"C__CATG__IP-_net":["C__CATG__IP-_net"],"C__CATG__IP-_all_ips":["C__CATG__IP-_all_ips"],"C__CATG__IP-_fqdn":["C__CATG__IP-_fqdn"],"C__CATG__IP-_dns_domain":["C__CATG__IP-_dns_domain"],"C__CATG__IP-_use_standard_gateway":["C__CATG__IP-_use_standard_gateway"],"C__CATG__CONNECTOR-fiber_wave_lengths":["C__CATG__CONNECTOR-fiber_wave_lengths"],"C__CATG__CONNECTOR-used_fiber_lead_rx":["C__CATG__CONNECTOR-used_fiber_lead_rx"],"C__CATG__CONNECTOR-used_fiber_lead_tx":["C__CATG__CONNECTOR-used_fiber_lead_tx"],"C__CATG__CONNECTOR-_assigned_category":["C__CATG__CONNECTOR-_assigned_category"],"C__CATG__INVOICE-_amount":["C__CATG__INVOICE-_amount"],"C__CATG__RAID-_storages":["C__CATG__RAID-_storages"],"C__CATG__LDEV_SERVER-_capacity":["C__CATG__LDEV_SERVER-_capacity"],"C__CATG__CLUSTER-cluster_service":["C__CATG__CLUSTER-cluster_service"],"C__CATG__CLUSTER-_administration_service":["C__CATG__CLUSTER-_administration_service"],"C__CATG__CLUSTER-_cluster_members":["C__CATG__CLUSTER-_cluster_members"],"C__CATG__CLUSTER-_cluster_service":["C__CATG__CLUSTER-_cluster_service"],"C__CATG__CLUSTER_SERVICE-hostaddresses":["C__CATG__CLUSTER_SERVICE-hostaddresses"],"C__CATG__CLUSTER_SERVICE-drives":["C__CATG__CLUSTER_SERVICE-drives"],"C__CATG__CLUSTER_SERVICE-shares":["C__CATG__CLUSTER_SERVICE-shares"],"C__CATG__CLUSTER_SERVICE-default_server":["C__CATG__CLUSTER_SERVICE-default_server"],"C__CATG__COMPUTING_RESOURCES-_ram":["C__CATG__COMPUTING_RESOURCES-_ram"],"C__CATG__COMPUTING_RESOURCES-_cpu":["C__CATG__COMPUTING_RESOURCES-_cpu"],"C__CATG__COMPUTING_RESOURCES-_disc_space":["C__CATG__COMPUTING_RESOURCES-_disc_space"],"C__CATG__COMPUTING_RESOURCES-_network_bandwidth":["C__CATG__COMPUTING_RESOURCES-_network_bandwidth"],"C__CATG__VIRTUAL_SWITCH-ports":["C__CATG__VIRTUAL_SWITCH-ports"],"C__CATG__VIRTUAL_SWITCH-portgroup":["C__CATG__VIRTUAL_SWITCH-portgroup"],"C__CATG__VIRTUAL_SWITCH-serviceconsoleports":["C__CATG__VIRTUAL_SWITCH-serviceconsoleports"],"C__CATG__VIRTUAL_SWITCH-vmkernelports":["C__CATG__VIRTUAL_SWITCH-vmkernelports"],"C__CATG__VIRTUAL_DEVICE-host_stor_device":["C__CATG__VIRTUAL_DEVICE-host_stor_device"],"C__CATG__VIRTUAL_DEVICE-host_ldev_client":["C__CATG__VIRTUAL_DEVICE-host_ldev_client"],"C__CATG__VIRTUAL_DEVICE-host_drive":["C__CATG__VIRTUAL_DEVICE-host_drive"],"C__CATG__VIRTUAL_DEVICE-host_port":["C__CATG__VIRTUAL_DEVICE-host_port"],"C__CATG__VIRTUAL_DEVICE-host_interface":["C__CATG__VIRTUAL_DEVICE-host_interface"],"C__CATG__VIRTUAL_DEVICE-local_stor_device":["C__CATG__VIRTUAL_DEVICE-local_stor_device"],"C__CATG__VIRTUAL_DEVICE-local_port":["C__CATG__VIRTUAL_DEVICE-local_port"],"C__CATG__VIRTUAL_DEVICE-local_interface":["C__CATG__VIRTUAL_DEVICE-local_interface"],"C__CATG__VIRTUAL_DEVICE-storage_type":["C__CATG__VIRTUAL_DEVICE-storage_type"],"C__CATG__VIRTUAL_DEVICE-network_type":["C__CATG__VIRTUAL_DEVICE-network_type"],"C__CATG__VIRTUAL_DEVICE-switch_port_group":["C__CATG__VIRTUAL_DEVICE-switch_port_group"],"C__CATG__VIRTUAL_DEVICE-cluster_storage":["C__CATG__VIRTUAL_DEVICE-cluster_storage"],"C__CATG__VIRTUAL_DEVICE-cluster_interface":["C__CATG__VIRTUAL_DEVICE-cluster_interface"],"C__CATG__VIRTUAL_DEVICE-virtual_network_type":["C__CATG__VIRTUAL_DEVICE-virtual_network_type"],"C__CATG__VIRTUAL_DEVICE-_host_resource":["C__CATG__VIRTUAL_DEVICE-_host_resource"],"C__CATG__VIRTUAL_DEVICE-_type":["C__CATG__VIRTUAL_DEVICE-_type"],"C__CATG__VIRTUAL_DEVICE-_local_device":["C__CATG__VIRTUAL_DEVICE-_local_device"],"C__CATG__BACKUP__ASSIGNED_OBJECTS-backup":["C__CATG__BACKUP__ASSIGNED_OBJECTS-backup"],"C__CATG__GROUP_MEMBERSHIPS-connected_object":["C__CATG__GROUP_MEMBERSHIPS-connected_object"],"C__CATG__RELATION-_type":["C__CATG__RELATION-_type"],"C__CATG__RELATION-_relation":["C__CATG__RELATION-_relation"],"C__CATG__RELATION-_relation_overview":["C__CATG__RELATION-_relation_overview"],"C__CATG__DATABASE_ASSIGNMENT-database_assignment":["C__CATG__DATABASE_ASSIGNMENT-database_assignment"],"C__CATG__DATABASE_ASSIGNMENT-runs_on":["C__CATG__DATABASE_ASSIGNMENT-runs_on"],"C__CATG__PASSWD-_password":["C__CATG__PASSWD-_password"],"C__CATG__SOA_STACKS-_soa_stack_object":["C__CATG__SOA_STACKS-_soa_stack_object"],"C__CATG__SOA_STACKS-_soa_stack_components":["C__CATG__SOA_STACKS-_soa_stack_components"],"C__CATG__PLANNING-_start":["C__CATG__PLANNING-_start"],"C__CATG__PLANNING-_end":["C__CATG__PLANNING-_end"],"C__CATG__AUDIT-commission":["C__CATG__AUDIT-commission"],"C__CATG__AUDIT-_commission":["C__CATG__AUDIT-_commission"],"C__CATG__AUDIT-_responsible":["C__CATG__AUDIT-_responsible"],"C__CATG__AUDIT-_involved":["C__CATG__AUDIT-_involved"],"C__CATG__LOGICAL_UNIT-_parent":["C__CATG__LOGICAL_UNIT-_parent"],"C__CATG__ASSIGNED_WORKSTATION-_parent":["C__CATG__ASSIGNED_WORKSTATION-_parent"],"C__CATG__PERSON_ASSIGNED_WORKSTATION-_assigned_workstations":["C__CATG__PERSON_ASSIGNED_WORKSTATION-_assigned_workstations"],"C__CATG__CONTRACT_ASSIGNMENT-_assigned_contract":["C__CATG__CONTRACT_ASSIGNMENT-_assigned_contract"],"C__CATG__MAIL_ADDRESSES-_primary_email":["C__CATG__MAIL_ADDRESSES-_primary_email"],"C__CATG__MAIL_ADDRESSES-_emails":["C__CATG__MAIL_ADDRESSES-_emails"],"C__CATG__VOIP_PHONE_LINE-associated_devices":["C__CATG__VOIP_PHONE_LINE-associated_devices"],"C__CATG__VIRTUAL_SUPERNET-_supernet_link":["C__CATG__VIRTUAL_SUPERNET-_supernet_link"],"C__CATG__SLA-_sla_times":["C__CATG__SLA-_sla_times"],"C__CATG__NAGIOS-address":["C__CATG__NAGIOS-address"],"C__CATG__NAGIOS-check_command":["C__CATG__NAGIOS-check_command"],"C__CATG__NAGIOS-check_period":["C__CATG__NAGIOS-check_period"],"C__CATG__NAGIOS-notification_period":["C__CATG__NAGIOS-notification_period"],"C__CATG__NAGIOS-escalations":["C__CATG__NAGIOS-escalations"],"C__CATG__NAGIOS_SERVICE_DEF-check_command":["C__CATG__NAGIOS_SERVICE_DEF-check_command"],"C__CATG__NAGIOS_SERVICE_DEF-check_period":["C__CATG__NAGIOS_SERVICE_DEF-check_period"],"C__CATG__NAGIOS_SERVICE_DEF-notification_interval":["C__CATG__NAGIOS_SERVICE_DEF-notification_interval"],"C__CATG__NAGIOS_SERVICE_DEF-notification_period":["C__CATG__NAGIOS_SERVICE_DEF-notification_period"],"C__CATG__NAGIOS_SERVICE_DEF-escalations":["C__CATG__NAGIOS_SERVICE_DEF-escalations"],"C__CATG__NAGIOS_REFS_SERVICES_BACKWARDS-assigned_objects":["C__CATG__NAGIOS_REFS_SERVICES_BACKWARDS-assigned_objects"],"C__CATG__NAGIOS_SERVICE_TPL_DEF-check_command":["C__CATG__NAGIOS_SERVICE_TPL_DEF-check_command"],"C__CATG__NAGIOS_SERVICE_TPL_DEF-check_period":["C__CATG__NAGIOS_SERVICE_TPL_DEF-check_period"],"C__CATG__NAGIOS_SERVICE_TPL_DEF-notification_period":["C__CATG__NAGIOS_SERVICE_TPL_DEF-notification_period"],"C__CATG__NAGIOS_SERVICE_TPL_DEF-escalations":["C__CATG__NAGIOS_SERVICE_TPL_DEF-escalations"],"C__CATG__NAGIOS_HOST_TPL_DEF-check_period":["C__CATG__NAGIOS_HOST_TPL_DEF-check_period"],"C__CATG__NAGIOS_HOST_TPL_DEF-notification_period":["C__CATG__NAGIOS_HOST_TPL_DEF-notification_period"],"C__CATG__NAGIOS_HOST_TPL_DEF-check_command":["C__CATG__NAGIOS_HOST_TPL_DEF-check_command"],"C__CATG__NAGIOS_HOST_TPL_DEF-escalations":["C__CATG__NAGIOS_HOST_TPL_DEF-escalations"],"C__CATG__NAGIOS_SERVICE_DEP-host":["C__CATG__NAGIOS_SERVICE_DEP-host"],"C__CATG__NAGIOS_SERVICE_DEP-host_dependency":["C__CATG__NAGIOS_SERVICE_DEP-host_dependency"],"C__CATG__NAGIOS_SERVICE_DEP-execution_fail_criteria":["C__CATG__NAGIOS_SERVICE_DEP-execution_fail_criteria"],"C__CATG__NAGIOS_SERVICE_DEP-notification_fail_criteria":["C__CATG__NAGIOS_SERVICE_DEP-notification_fail_criteria"],"C__CATG__NAGIOS_SERVICE_DEP-dependency_period":["C__CATG__NAGIOS_SERVICE_DEP-dependency_period"],"C__CATG__LIVESTATUS-_livestatus_state":["C__CATG__LIVESTATUS-_livestatus_state"],"C__CATG__LIVESTATUS-_livestatus_state_button":["C__CATG__LIVESTATUS-_livestatus_state_button"],"C__CATG__NET_LISTENER-opened_by":["C__CATG__NET_LISTENER-opened_by"],"C__CATG__NDO-ndo_state":["C__CATG__NDO-ndo_state"],"C__CATG__NDO-ndo_state_button":["C__CATG__NDO-ndo_state_button"],"C__CATG__CABLE-_connection":["C__CATG__CABLE-_connection"],"C__CATG__CABLE-_length":["C__CATG__CABLE-_length"],"C__CATG__SERVICE-service_alias":["C__CATG__SERVICE-service_alias"],"C__CATG__OPERATING_SYSTEM-assigned_license_key":["C__CATG__OPERATING_SYSTEM-assigned_license_key"],"C__CATG__OPERATING_SYSTEM-assigned_databases":["C__CATG__OPERATING_SYSTEM-assigned_databases"],"C__CATG__OPERATING_SYSTEM-_variant":["C__CATG__OPERATING_SYSTEM-_variant"],"C__CATG__OPERATING_SYSTEM-_assigned_license_key":["C__CATG__OPERATING_SYSTEM-_assigned_license_key"],"C__CATG__OPERATING_SYSTEM-_assigned_database_schema":["C__CATG__OPERATING_SYSTEM-_assigned_database_schema"],"C__CATG__WAN-_capacity_up":["C__CATG__WAN-_capacity_up"],"C__CATG__WAN-_max_capacity_up":["C__CATG__WAN-_max_capacity_up"],"C__CATG__WAN-_capacity_down":["C__CATG__WAN-_capacity_down"],"C__CATG__WAN-_max_capacity_down":["C__CATG__WAN-_max_capacity_down"],"C__CATG__WAN-_net":["C__CATG__WAN-_net"],"C__CATG__WAN-_router":["C__CATG__WAN-_router"],"C__CATG__NET_ZONE_SCOPES-from_to":["C__CATG__NET_ZONE_SCOPES-from_to"],"C__CATG__BSM_PROFILE-operation":["C__CATG__BSM_PROFILE-operation"],"C__CATG__BSM_PROFILE-operation_value":["C__CATG__BSM_PROFILE-operation_value"],"C__CATG__BSM_PROFILE-default_status":["C__CATG__BSM_PROFILE-default_status"],"C__CATG__BSM_PROFILE-is_template":["C__CATG__BSM_PROFILE-is_template"],"C__CATG__BSM_PROFILE-template":["C__CATG__BSM_PROFILE-template"],"C__CATG__BSM_PROFILE-profile":["C__CATG__BSM_PROFILE-profile"],"C__CATG__RISK_ASSESSMENT-asset_owner":["C__CATG__RISK_ASSESSMENT-asset_owner"],"C__CATG__RISK_ASSESSMENT-risk_owner":["C__CATG__RISK_ASSESSMENT-risk_owner"],"C__CATG__RISK_ASSESSMENT-consequences":["C__CATG__RISK_ASSESSMENT-consequences"],"C__CATG__RISK_ASSESSMENT-likelihood":["C__CATG__RISK_ASSESSMENT-likelihood"],"C__CATG__RISK_ASSESSMENT-level_of_risk":["C__CATG__RISK_ASSESSMENT-level_of_risk"],"C__CATG__RISK_ASSESSMENT-existing_controls":["C__CATG__RISK_ASSESSMENT-existing_controls"],"C__CATG__RISK_ASSESSMENT-risk_treatment__assigned_control":["C__CATG__RISK_ASSESSMENT-risk_treatment__assigned_control"],"C__CATG__RISK_ASSESSMENT-risk_treatment__consequences":["C__CATG__RISK_ASSESSMENT-risk_treatment__consequences"],"C__CATG__RISK_ASSESSMENT-risk_treatment__level_of_risk":["C__CATG__RISK_ASSESSMENT-risk_treatment__level_of_risk"],"C__CATG__RISK_ASSESSMENT-_threat":["C__CATG__RISK_ASSESSMENT-_threat"],"C__CATG__RISK_ASSESSMENT-_vulnerability":["C__CATG__RISK_ASSESSMENT-_vulnerability"],"C__CATG__RISK_ASSESSMENT-_affected_protection_objectives":["C__CATG__RISK_ASSESSMENT-_affected_protection_objectives"],"C__CATG__RISK_ASSESSMENT-_asset_owner":["C__CATG__RISK_ASSESSMENT-_asset_owner"],"C__CATG__RISK_ASSESSMENT-_risk_owner":["C__CATG__RISK_ASSESSMENT-_risk_owner"],"C__CATG__RISK_ASSESSMENT-_consequences":["C__CATG__RISK_ASSESSMENT-_consequences"],"C__CATG__RISK_ASSESSMENT-_level_of_risk":["C__CATG__RISK_ASSESSMENT-_level_of_risk"],"C__CATG__RISK_ASSESSMENT-_existing_controls":["C__CATG__RISK_ASSESSMENT-_existing_controls"],"C__CATG__RISK_ASSESSMENT-_risk_treatment__assigned_control":["C__CATG__RISK_ASSESSMENT-_risk_treatment__assigned_control"],"C__CATG__RISK_ASSESSMENT-_risk_treatment__consequences":["C__CATG__RISK_ASSESSMENT-_risk_treatment__consequences"],"C__CATG__RISK_ASSESSMENT-_risk_treatment__level_of_risk":["C__CATG__RISK_ASSESSMENT-_risk_treatment__level_of_risk"],"C__CATG__ISO27001_ISMS-application_scope":["C__CATG__ISO27001_ISMS-application_scope"],"C__CATG__ISO27001_THREAT-protection_objectives":["C__CATG__ISO27001_THREAT-protection_objectives"],"C__CATG__BSM_CONFIG-ownership":["C__CATG__BSM_CONFIG-ownership"],"C__CATG__BSM_CONFIG-business":["C__CATG__BSM_CONFIG-business"],"C__CATG__BSM_CONFIG-application":["C__CATG__BSM_CONFIG-application"],"C__CATG__BSM_CONFIG-application_services":["C__CATG__BSM_CONFIG-application_services"],"C__CATG__BSM_CONFIG-system":["C__CATG__BSM_CONFIG-system"],"C__CATG__BSM_CONFIG-system_services":["C__CATG__BSM_CONFIG-system_services"],"C__CATG__BSM_CONFIG-hardware":["C__CATG__BSM_CONFIG-hardware"],"C__CATG__BSM_CONFIG-hardware_services":["C__CATG__BSM_CONFIG-hardware_services"],"C__CATG__BSM_CONFIG-infrastructure":["C__CATG__BSM_CONFIG-infrastructure"],"C__CATG__BSM_CONFIG-infrastructure_services":["C__CATG__BSM_CONFIG-infrastructure_services"],"C__CATG__BSM_OPERATION-operation":["C__CATG__BSM_OPERATION-operation"],"C__CATG__BSM_OPERATION-operation_value":["C__CATG__BSM_OPERATION-operation_value"],"C__CATG__BSM_OPERATION-filter":["C__CATG__BSM_OPERATION-filter"],"C__CATG__BSM_OPERATION-config_items":["C__CATG__BSM_OPERATION-config_items"],"C__CATG__BSM_GRAPH-graph":["C__CATG__BSM_GRAPH-graph"],"C__CATG__BSM_RELATION-filter":["C__CATG__BSM_RELATION-filter"],"C__CATG__BSM_RELATION-config_items":["C__CATG__BSM_RELATION-config_items"],"C__CATG__DATABASE_TABLE-assigned_schema":["C__CATG__DATABASE_TABLE-assigned_schema"],"C__CATG__DATABASE_SA-assigned_database":["C__CATG__DATABASE_SA-assigned_database"],"C__CATG__DATABASE_SA-assigned_instance":["C__CATG__DATABASE_SA-assigned_instance"],"C__CATG__DATABASE_SA-assigned_schemas":["C__CATG__DATABASE_SA-assigned_schemas"],"C__CATS__SERVICE-installation_count":["C__CATS__SERVICE-installation_count"],"C__CATS__SERVICE-_installation_count":["C__CATS__SERVICE-_installation_count"],"C__CATS__WAN-_capacity":["C__CATS__WAN-_capacity"],"C__CATS__EMERGENCY_PLAN-_time_needed":["C__CATS__EMERGENCY_PLAN-_time_needed"],"C__CATS__MONITOR-_size":["C__CATS__MONITOR-_size"],"C__CATS__ROUTER-gateway_address":["C__CATS__ROUTER-gateway_address"],"C__CATS__FILE-md5_hash":["C__CATS__FILE-md5_hash"],"C__CATS__APPLICATION-installation_count":["C__CATS__APPLICATION-installation_count"],"C__CATS__APPLICATION-_installation_count":["C__CATS__APPLICATION-_installation_count"],"C__CATS__NET-gateway":["C__CATS__NET-gateway"],"C__CATS__NET-dns_server":["C__CATS__NET-dns_server"],"C__CATS__NET-dns_domain":["C__CATS__NET-dns_domain"],"C__CATS__NET-address_v6":["C__CATS__NET-address_v6"],"C__CATS__NET-_address_range":["C__CATS__NET-_address_range"],"C__CATS__NET-_address_with_suffix":["C__CATS__NET-_address_with_suffix"],"C__CATS__NET-_address":["C__CATS__NET-_address"],"C__CATS__NET-_free_addresses":["C__CATS__NET-_free_addresses"],"C__CATS__NET-_netmask":["C__CATS__NET-_netmask"],"C__CATS__NET-_layer2_assignments":["C__CATS__NET-_layer2_assignments"],"C__CATS__NET-_gateway":["C__CATS__NET-_gateway"],"C__CATS__LICENCE_LIST-_used_licenses":["C__CATS__LICENCE_LIST-_used_licenses"],"C__CATS__LICENCE_LIST-_free_licenses":["C__CATS__LICENCE_LIST-_free_licenses"],"C__CATS__LICENCE_LIST-_cost":["C__CATS__LICENCE_LIST-_cost"],"C__CATS__FILE_VERSIONS-file_physical":["C__CATS__FILE_VERSIONS-file_physical"],"C__CATS__FILE_VERSIONS-file_content":["C__CATS__FILE_VERSIONS-file_content"],"C__CATS__FILE_VERSIONS-upload_date":["C__CATS__FILE_VERSIONS-upload_date"],"C__CATS__FILE_VERSIONS-md5_hash":["C__CATS__FILE_VERSIONS-md5_hash"],"C__CATS__FILE_VERSIONS-uploaded_by":["C__CATS__FILE_VERSIONS-uploaded_by"],"C__CATS__FILE_OBJECTS-assigned_objects":["C__CATS__FILE_OBJECTS-assigned_objects"],"C__CATS__EMERGENCY_PLAN_LINKED_OBJECTS-_time_needed":["C__CATS__EMERGENCY_PLAN_LINKED_OBJECTS-_time_needed"],"C__CATS__UPS-_autonomy_time":["C__CATS__UPS-_autonomy_time"],"C__CATS__UPS-_charge_time":["C__CATS__UPS-_charge_time"],"C__CATS__EPS-_autonomy_time":["C__CATS__EPS-_autonomy_time"],"C__CATS__EPS-_warmup_time":["C__CATS__EPS-_warmup_time"],"C__CATS__EPS-_fuel_tank":["C__CATS__EPS-_fuel_tank"],"C__CATS__ORGANIZATION_MASTER_DATA-_headquarter":["C__CATS__ORGANIZATION_MASTER_DATA-_headquarter"],"C__CATS__ORGANIZATION_PERSONS-_object":["C__CATS__ORGANIZATION_PERSONS-_object"],"C__CATS__PERSON_MASTER-_username":["C__CATS__PERSON_MASTER-_username"],"C__CATS__PERSON_MASTER-_organisation":["C__CATS__PERSON_MASTER-_organisation"],"C__CATS__PERSON_MASTER-_mail":["C__CATS__PERSON_MASTER-_mail"],"C__CATS__PERSON_LOGIN-user_pass2":["C__CATS__PERSON_LOGIN-user_pass2"],"C__CATS__PERSON_ASSIGNED_GROUPS-contact":["C__CATS__PERSON_ASSIGNED_GROUPS-contact"],"C__CATS__PERSON_ASSIGNED_GROUPS-_connected_object":["C__CATS__PERSON_ASSIGNED_GROUPS-_connected_object"],"C__CATS__ORGANIZATION_CONTACT_ASSIGNMENT-object":["C__CATS__ORGANIZATION_CONTACT_ASSIGNMENT-object"],"C__CATS__PERSON_GROUP_CONTACT_ASSIGNMENT-object":["C__CATS__PERSON_GROUP_CONTACT_ASSIGNMENT-object"],"C__CATS__CLUSTER_SERVICE-cluster":["C__CATS__CLUSTER_SERVICE-cluster"],"C__CATS__CLUSTER_SERVICE-hostaddresses":["C__CATS__CLUSTER_SERVICE-hostaddresses"],"C__CATS__CLUSTER_SERVICE-shares":["C__CATS__CLUSTER_SERVICE-shares"],"C__CATS__CLUSTER_SERVICE-_cluster":["C__CATS__CLUSTER_SERVICE-_cluster"],"C__CATS__DATABASE_SCHEMA-instance":["C__CATS__DATABASE_SCHEMA-instance"],"C__CATS__DATABASE_SCHEMA-_instance":["C__CATS__DATABASE_SCHEMA-_instance"],"C__CATS__APPLICATION_ASSIGNED_OBJ-object":["C__CATS__APPLICATION_ASSIGNED_OBJ-object"],"C__CATS__APPLICATION_ASSIGNED_OBJ-assigned_license_key":["C__CATS__APPLICATION_ASSIGNED_OBJ-assigned_license_key"],"C__CATS__MIDDLEWARE-installation_count":["C__CATS__MIDDLEWARE-installation_count"],"C__CATS__MIDDLEWARE-_installation_count":["C__CATS__MIDDLEWARE-_installation_count"],"C__CATS__NET_IP_ADDRESSES-ip_address_link":["C__CATS__NET_IP_ADDRESSES-ip_address_link"],"C__CATS__LAYER2_NET-layer3_assignments":["C__CATS__LAYER2_NET-layer3_assignments"],"C__CATS__CONTRACT-_notice_period":["C__CATS__CONTRACT-_notice_period"],"C__CATS__CONTRACT-_maintenance_period":["C__CATS__CONTRACT-_maintenance_period"],"C__CATS__CONTRACT-_start_date":["C__CATS__CONTRACT-_start_date"],"C__CATS__CONTRACT-_end_date":["C__CATS__CONTRACT-_end_date"],"C__CATS__CONTRACT-_notice_date":["C__CATS__CONTRACT-_notice_date"],"C__CATS__CONTRACT-_costs":["C__CATS__CONTRACT-_costs"],"C__CATS__CONTRACT_ALLOCATION-assigned_object":["C__CATS__CONTRACT_ALLOCATION-assigned_object"],"C__CATS__GROUP_TYPE-report":["C__CATS__GROUP_TYPE-report"],"C__CATS__OPERATING_SYSTEM-installation_count":["C__CATS__OPERATING_SYSTEM-installation_count"],"C__CATS__OPERATING_SYSTEM-_installation_count":["C__CATS__OPERATING_SYSTEM-_installation_count"],"C__CATS__DATABASE_INSTALLATION-object":["C__CATS__DATABASE_INSTALLATION-object"],"C__CATS__DATABASE_INSTALLATION-assigned_license_key":["C__CATS__DATABASE_INSTALLATION-assigned_license_key"],"C__CATG__CONNECTOR-from_object":["C__CATG__CONNECTOR-from_object"],"C__CATG__CONNECTOR-from_category":["C__CATG__CONNECTOR-from_category"],"C__CATG__CONNECTOR-remote_category":["C__CATG__CONNECTOR-remote_category"],"C__CATG__CONNECTOR-remote_type":["C__CATG__CONNECTOR-remote_type"],"C__CATG__CONNECTOR-remote_title":["C__CATG__CONNECTOR-remote_title"],"C__CATG__CONNECTOR-remote_object":["C__CATG__CONNECTOR-remote_object"],"C__CATG__LOCATION-slot":["C__CATG__LOCATION-slot"]}';
        $blacklist = json_decode($blacklist_json, true);

        unset($blacklist['C__CATG__VIRTUAL_MACHINE-primary']);

        $blacklist['C__CATS__PERSON_LOGIN-user_pass'] = ["property_id" => "C__CATS__PERSON_LOGIN-user_pass" ];
        $blacklist['C__CATG__OPERATING_SYSTEM-assigned_it_service'] = ["property_id" => "C__CATG__OPERATING_SYSTEM-assigned_it_service" ];
        $blacklist['C__CATG__IP-primary_fqdn'] = ["property_id" => "C__CATG__IP-primary_fqdn" ];
        $blacklist['C__CATG__CLUSTER-cluster_members'] = ["property_id" => "C__CATG__CLUSTER-cluster_members" ];
        $blacklist['C__CATG__RM_CONTROLLER_BACKWARD-connected_object'] = ["property_id" => "C__CATG__RM_CONTROLLER_BACKWARD-connected_object" ];
        $blacklist['C__CATG__CONTACT-description'] = ["property_id" => "C__CATG__CONTACT-description" ];
        $blacklist['C__CATG__GUEST_SYSTEMS-runs_on'] = ["property_id" => "C__CATG__GUEST_SYSTEMS-runs_on"];
        $blacklist['C__CATG__GUEST_SYSTEMS-hostname'] = ["property_id" => "C__CATG__GUEST_SYSTEMS-hostname"];
        $blacklist['C__CATG__OPERATING_SYSTEM-_assigned_variant_combined'] = ["property_id" => "C__CATG__OPERATING_SYSTEM-_assigned_variant_combined"];
        $blacklist['C__CATG__SMVIEW_CABLE_SECTION-section_elements'] = ["property_id" => "C__CATG__SMVIEW_CABLE_SECTION-section_elements"];
        $blacklist['C__CATG__SMVIEW_CABLE_SECTION-locations'] = ["property_id" => "C__CATG__SMVIEW_CABLE_SECTION-locations"];

        $blacklist_dialog = [
            'C__CATG__IP-assigned_port',
            'C__CATG__IP-assigned_logical_port',
        ];

        $this->getValidationData();

        $rawProperties = [];
        $dao = smview_cmdb_dao_category_property::instance($this->m_db);
        if (! empty($objectTypeConst)) {
            $rawProperties = $this->_get_properties_by_object_type_const($objectTypeConst);
        } else {
            $l_res = $dao->retrieve_properties_shd(null, null, null, null, "", true, null);
            while ($l_data = $l_res->get_row()) {
                $rawProperties[] = $l_data;
            }
        }

        $language = isys_application::instance()->container->get('language');
        $properties = array();

        // init dialog instance here to keep category properties in cache
        $isys_api_model_cmdb_dialog = new isys_api_model_shd_dialog_cache_hack(new isys_cmdb_dao($this->m_db));
        foreach ($rawProperties as $l_data) {
            //Check Blacklist
            $propertyKey = $l_data["const"] . "-" . $l_data["key"];
            if (array_key_exists($propertyKey, $blacklist)) {
                continue;
            }

            //Check Horizontale Linie Key start with hr_c_
            if (strpos($l_data["key"], "hr_c_") !== false) {
                continue;
            }

            try {
                if ($withInfo == true) {
                    $isys_api_model_cmdb_category_info = new isys_api_model_cmdb_category_info(new isys_cmdb_dao($this->m_db));
                    $info = $isys_api_model_cmdb_category_info->read(["catgID" => $l_data["const"]]);
                    $l_data['info'] = $info;
                }
            } catch (Exception $ex) {
            }

            //Translate
            $l_data['title'] = $language->get($l_data['title']);
            if ($l_data["catg_title"] != null) {
                $l_data['cat_title'] = $language->get($l_data["catg_title"]);
            } elseif ($l_data["cats_title"] != null) {
                $l_data['cat_title'] = $language->get($l_data["cats_title"]);
            } elseif ($l_data["catg_custom_title"] != null) {
                $l_data['cat_title'] = $language->get($l_data["catg_custom_title"]);
            } else {
                $l_data['cat_title'] = "";
            }

            unset($l_data["catg_title"]);
            unset($l_data["cats_title"]);
            unset($l_data["catg_custom_title"]);

            $l_data = $this->getBrowser_obj_type($l_data);
            if ($withDialog == true) {
                if (in_array($propertyKey, $blacklist_dialog)) {
                    // do not list dialog elements
                    $l_data["dialog"] = [];
                } else {
                    $l_data = $this->getDialog($l_data, $isys_api_model_cmdb_dialog, $status);
                }
            }

            //set C__CATG__GLOBAL-type
            if ($propertyKey == "C__CATG__GLOBAL-type") {
                $dialog = [];

                $_dao = new isys_cmdb_dao($this->m_db, null);

                // Data retrieval:
                $l_data_object_type = $_dao->get_object_types_by_properties(
                    null,
                    'title'
                );

                // Data formatting:
                while ($l_row_object_type = $l_data_object_type->get_row()) {
                    $dialog[] = ["id" => $l_row_object_type["isys_obj_type__id"],"title" => $language->get($l_row_object_type["isys_obj_type__title"])
                        ,"const" => $l_row_object_type["isys_obj_type__id"]];
                }

                usort($dialog, function ($a, $b) {
                    return strcasecmp(strval($a['title']), strval($b['title']));
                });

                $dialog[] = ["id" => "-1","title" => $language->get("LC__MODULE__SMVIEW__NO_VALUE") ,"const" => ""];
                $dialog[] = ["id" => "-99","title" => "-" ,"const" => ""];
                $l_data["dialog"] = $dialog;
            }

            //delete
            if ($l_data["const"] == "C__CATG__SMVIEW_CABLE_PIN") {
                continue;
            }

            //rewrite Language_const
            if ($l_data["const"] == "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT") {
                switch ($l_data["key"]) {
                    case "id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__ID");
                        break;
                    case "section_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__SECTION_ID");
                        break;
                    case "cable_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__CABLE_ID");
                        break;
                    case "wire_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_ID");
                        break;
                    case "obj_in_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_OBJECT_ID");
                        break;
                    case "pin_in_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_ID");
                        break;
                    case "obj_out_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_OBJECT_ID");
                        break;
                    case "pin_out_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_ID");
                        break;
                }
            }
            if ($l_data["const"] == "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT" || $l_data["const"] == "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT") {
                switch ($l_data["key"]) {
                    case "id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__ID");
                        break;
                    case "route_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_ID");
                        break;
                    case "cable_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__CABLE_ID");
                        break;
                    case "wire_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_ID");
                        break;
                    case "obj_in_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_OBJECT_ID");
                        break;
                    case "pin_in_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_ID");
                        break;
                    case "obj_out_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_OBJECT_ID");
                        break;
                    case "pin_out_id":
                        $l_data["title"] = $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_ID");
                        break;
                    case "description":
                        continue 2;
                }
            }

            switch($propertyKey){
                case "C__CATG__RELATION-relation_type":
                    $l_data["readonly"] = "true";
                    break;
            }

            $l_data["mandatory"] = $this->getMandatory($l_data["catg"], $l_data["key"]);

            //add dialog+ info
            /** @var isys_cmdb_dao_category $realDao */
            $realDao = call_user_func($l_data['class'].'::instance', $this->m_db);

            if($l_data['class'] == 'isys_cmdb_dao_category_g_custom_fields') {
                $realDao->set_catg_custom_id($l_data['catg_custom']);
            }

            $propdata = $realDao->get_properties()[$l_data['key']];
            $l_data['field_type'] = $propdata['info']['type'];
            if($propdata['info']['type'] == 'dialog_plus') {
                $l_data['dialog_plus_identifier'] = $propdata["ui"]["params"]["identifier"] ?? null;
            }

            $properties[] = $l_data;
        }

        //check Livestatus
        if (class_exists('isys_module_livestatus')) {
            $dialog = [
                ["id" => "-1","const" => "C__SHD__LIVESTATUS_GREY","title" => $language->get("LC__MODULE__SMVIEW__NO_STATUS")],
                ["id" => "-99","title" => "-" ,"const" => ""],
                ["id" => "0","const" => "C__SHD__LIVESTATUS_OK","title" => "UP"],
                ["id" => "2","const" => "C__SHD__LIVESTATUS_DOWN","title" => "DOWN"],
                ["id" => "3","const" => "C__SHD__LIVESTATUS_UNKNOWN","title" => "UNKNOWN"],
            ];

            $properties[] = ["id" => "65000", "catg" => "C__CATG__MONITORING", "const" => "C__SHD__LIVESTATUS",
                             "title" => $language->get("LC__OVERVIEW__STATE"), "key" => "status", "dialog" => $dialog];
            $properties[] = ["id" => "65001", "catg" => "C__CATG__MONITORING", "const" => "C__SHD__LIVESTATUS",
                             "title" => $language->get("LC__MODULE__SMVIEW__STATUS_SERVICES"), "key" => "service_status", "search_disable" => "true"];
            $properties[] = ["id" => "65002", "catg" => "C__CATG__MONITORING", "const" => "C__SHD__LIVESTATUS",
                             "title" => $language->get("LC__LIVESTATUS__OUTPUT"), "key" => "output"];

            //Livestatus mit Services
            $properties[] = ["id" => "65010", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "host_name", "key" => "host_name"];
            $properties[] = ["id" => "65011", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "description", "key" => "description"];
            $properties[] = ["id" => "65012", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "display_name", "key" => "display_name"];
            $properties[] = ["id" => "65013", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "check_command", "key" => "check_command"];
            $properties[] = ["id" => "65014", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "check_interval", "key" => "check_interval"];
            $properties[] = ["id" => "65015", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "max_check_attempts", "key" => "max_check_attempts"];
            $properties[] = ["id" => "65016", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "retry_interval", "key" => "retry_interval"];
            $properties[] = ["id" => "65017", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "last_check", "key" => "last_check"];
            $properties[] = ["id" => "65018", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "last_hard_state", "key" => "last_hard_state"];
            $properties[] = ["id" => "65019", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "last_state", "key" => "last_state"];
            $properties[] = ["id" => "65020", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "plugin_output", "key" => "plugin_output"];
            $properties[] = ["id" => "65021", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "perf_data", "key" => "perf_data"];
            $properties[] = ["id" => "65022", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "state", "key" => "state"];
            $properties[] = ["id" => "65023", "catg" => "136", "const" => "C__CATG__LIVESTATUS","special_column" => "true",  "title" => "state_type", "key" => "state_type"];
        }



        if (class_exists('isys_module_bsm')) {
            $dialog = [
                ["id" => "-1","const" => "C__SHD__SERVICESTATUS_GREY","title" => $language->get("LC__MODULE__SMVIEW__NO_STATUS")],
                ["id" => "-99","title" => "-" ,"const" => ""],
                ["id" => "0","const" => "C__SHD__SERVICESTATUS_OK","title" => "UP"],
                ["id" => "2","const" => "C__SHD__SERVICESTATUS_DOWN","title" => "DOWN"],
                ["id" => "3","const" => "C__SHD__SERVICESTATUS_UNKNOWN","title" => "UNKNOWN"],
            ];

            $properties[] = ["id" => "64000", "catg" => "136", "const" => "C__SHD__SERVICESTATUS",
                             "title" => $language->get("LC__OVERVIEW__STATE"), "key" => "status", "dialog" => $dialog];
            $properties[] = ["id" => "64001", "catg" => "136", "const" => "C__SHD__SERVICESTATUS",
                             "title" => $language->get("LC__CMDB__CATG__BSM__OUTPUT"), "key" => "output"];
        }

        $properties[] = ["id" => "66001", "catg" => "C__CATG__SMVIEW_CABLE", "const" => "C__CATG__SMVIEW_CABLE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PATCHED_WIRES"), "special_column" => "true", "key" => "cable_patched_wires"];

        $properties[] = ["id" => "66002", "catg" => "C__CATG__SMVIEW_CABLE", "const" => "C__CATG__SMVIEW_CABLE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__FREE_WIRES"), "special_column" => "true", "key" => "cable_free_wires"];

        $properties[] = ["id" => "66003", "catg" => "C__CATG__SMVIEW_CABLE", "const" => "C__CATG__SMVIEW_CABLE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__ACTUELL_CAPACITY"), "special_column" => "true", "key" => "cable_capacity"];

        $properties[] = ["id" => "66007", "catg" => "C__CATG__SMVIEW_CABLE", "const" => "C__CATG__SMVIEW_CABLE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__NAME"), "key" => "description_sort", "special_column" => "true"];

        $properties[] = ["id" => "66008", "catg" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__FREE_WIRES"), "special_column" => "true", "key" => "cable_free_wires"];
        $properties[] = ["id" => "66009", "catg" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PATCHED_WIRES"), "special_column" => "true", "key" => "cable_patched_wires"];
        $properties[] = ["id" => "66010", "catg" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__CAPACITY"), "special_column" => "true", "key" => "cable_max_capacity"];
        $properties[] = ["id" => "66011", "catg" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__ACTUELL_CAPACITY"), "special_column" => "true", "key" => "cable_capacity"];
        $properties[] = ["id" => "66012", "catg" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_STATE_OUT"), "special_column" => "true", "key" => "pin_out_state"];
        $properties[] = ["id" => "66013", "catg" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_SECTION_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_STATE_IN"), "special_column" => "true", "key" => "pin_in_state"];

        $properties[] = ["id" => "66308", "catg" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__FREE_WIRES"), "special_column" => "true", "key" => "cable_free_wires"];
        $properties[] = ["id" => "66309", "catg" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PATCHED_WIRES"), "special_column" => "true", "key" => "cable_patched_wires"];
        $properties[] = ["id" => "66310", "catg" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__CAPACITY"), "special_column" => "true", "key" => "cable_max_capacity"];
        $properties[] = ["id" => "66311", "catg" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__ACTUELL_CAPACITY"), "special_column" => "true", "key" => "cable_capacity"];
        $properties[] = ["id" => "66312", "catg" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_STATE_OUT"), "special_column" => "true", "key" => "pin_out_state"];
        $properties[] = ["id" => "66313", "catg" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_STATE_IN"), "special_column" => "true", "key" => "pin_in_state"];
        $properties[] = ["id" => "66314", "catg" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__SECTION_ID"), "special_column" => "true", "key" => "section_id"];
        $properties[] = ["id" => "66315", "catg" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__SECTION_NAME"), "special_column" => "true", "key" => "section_title"];

        $properties[] = ["id" => "66388", "catg" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__FREE_WIRES"), "special_column" => "true", "key" => "cable_free_wires"];
        $properties[] = ["id" => "66389", "catg" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PATCHED_WIRES"), "special_column" => "true", "key" => "cable_patched_wires"];
        $properties[] = ["id" => "66390", "catg" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__CAPACITY"), "special_column" => "true", "key" => "cable_max_capacity"];
        $properties[] = ["id" => "66391", "catg" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__ACTUELL_CAPACITY"), "special_column" => "true", "key" => "cable_capacity"];
        $properties[] = ["id" => "66392", "catg" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_STATE_OUT"), "special_column" => "true", "key" => "pin_out_state"];
        $properties[] = ["id" => "66393", "catg" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_STATE_IN"), "special_column" => "true", "key" => "pin_in_state"];
        $properties[] = ["id" => "66394", "catg" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__SECTION_ID"), "special_column" => "true", "key" => "section_id"];
        $properties[] = ["id" => "66395", "catg" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT", "const" => "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE_ELEMENT",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__SECTION_NAME"), "special_column" => "true", "key" => "section_title"];


        $properties[] = ["id" => "66103", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_DESCRIPTION"), "special_column" => "true", "key" => "pin_in"];

        $properties[] = ["id" => "66104", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_DESCRIPTION"), "special_column" => "true", "key" => "pin_out"];

        $properties[] = ["id" => "66105", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_SCOPE"), "special_column" => "true", "key" => "scope_in"];

        $properties[] = ["id" => "66106", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_SCOPE"), "special_column" => "true", "key" => "scope_out"];

        $properties[] = ["id" => "66107", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_OBJECT"), "special_column" => "true", "key" => "object_in"];

        $properties[] = ["id" => "66108", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_OBJECT"), "special_column" => "true", "key" => "object_out"];

        $properties[] = ["id" => "66109", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_PURPOSE"), "special_column" => "true", "key" => "purpose_in"];

        $properties[] = ["id" => "66110", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_PURPOSE"), "special_column" => "true", "key" => "purpose_out"];

        $properties[] = ["id" => "66111", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__LENGTH"), "special_column" => "true", "key" => "length"];

        $properties[] = ["id" => "66112", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__CAPACITY"), "special_column" => "true", "key" => "capacity"];

        $properties[] = ["id" => "66113", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__CABLE_NAME"), "special_column" => "true", "key" => "cable_name"];

        $properties[] = ["id" => "66114", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__CABLE_ID"), "special_column" => "true", "key" => "cable_id"];

        $properties[] = ["id" => "66115", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__PATCHED_WIRES"), "special_column" => "true", "key" => "cable_patched_wires"];

        $properties[] = ["id" => "66116", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__FREE_WIRES"), "special_column" => "true", "key" => "cable_free_wires"];

        $properties[] = ["id" => "66117", "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                         "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__ACTUELL_CAPACITY"), "special_column" => "true", "key" => "cable_capacity"];


        $properties[] = ["id" => "66118", "catg" => "C__CATG__GLOBAL", "const" => "C__CATG__GLOBAL",
            "title" =>  $language->get("LC__CMDB__CATG__SMVIEW__TYPE_GROUP_TITLE"), "special_column" => "true", "key" => "type_group_title"];

        $properties[] = ["id" => "66119", "catg" => "C__CATG__GLOBAL", "const" => "C__CATG__GLOBAL",
            "title" =>  $language->get("LC__CMDB__CATG__SMVIEW__GROUP_PICTURE_PATH"), "special_column" => "true", "key" => "group_image"];


        $route_properties = [
            'connection_count'         => 'LC__CMDB__CATG__SMVIEW_CABLE__CONNECTION_COUNT',
            'current_connection_count' => 'LC__CMDB__CATG__SMVIEW_CABLE__CURRENT_CONNECTION_COUNT',
            'permission'               => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_PERMISSION',
            'location'                 => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_LOCATION',
            'room'                     => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_ROOM',
            'device_type'              => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_DEVICE_TYPE',
            'device_number'            => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_DEVICE_NUMBER',
            'phone_number'             => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_PHONE_NUMBER',
            'phone_subscriber'         => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_PHONE_SUBSCRIBER',
            'hint'                     => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_HINT',
            'route_length'             => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_LENGTH',
            'measured_length'          => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_MEASURED_LENGTH',
            'measure_date'             => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_MEASURE_DATE',
            'tka_participant'          => 'LC__CMDB__CATG__SMVIEW_CABLE__TKA_PARTICIPANT',
            'is_external'              => 'LC__CMDB__CATG__SMVIEW_CABLE__IS_EXTERNAL',
            'is_rented'                => 'LC__CMDB__CATG__SMVIEW_CABLE__IS_RENTED',
            'damping_left1'            => 'LC__CMDB__CATG__SMVIEW_CABLE__DAMPING_LEFT1',
            'damping_left2'            => 'LC__CMDB__CATG__SMVIEW_CABLE__DAMPING_LEFT2',
            'damping_right1'           => 'LC__CMDB__CATG__SMVIEW_CABLE__DAMPING_RIGHT1',
            'damping_right2'           => 'LC__CMDB__CATG__SMVIEW_CABLE__DAMPING_RIGHT2',
        ];
        $property_id = 66118;
        foreach ($route_properties as $p => $label) {
            $properties[] = ["id" => $property_id, "catg" => "C__CATG__SMVIEW_CABLE_WIRE", "const" => "C__CATG__SMVIEW_CABLE_WIRE",
                "title" => $language->get($label), "special_column" => "true", "key" => $p];
            $property_id++;
        }

        $cable_pin_properties = [
            'in_description'      => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_IN") . " " .  $language->get("LC__CMDB__CATG__SMVIEW_CABLE__DESCRIPTION"),
            'in_scope'            => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_IN") . " " .$language->get("LC__CMDB__CATG__SMVIEW_CABLE__SCOPE"),
            'in_cable'            => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_IN") . " " .$language->get("LC__SHD__TELECOMMUNICATION_CABLE"),
            'in_cable_wire'       => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_IN") . " " .$language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_TITLE"),
            'in_connected_with'   => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_IN") . " " .$language->get("LC__CMDB__CATG__SMVIEW_CABLE__CONNECTED_WITH"),
            'in_connector_title'  => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_IN") . " " .$language->get("LC__CMDB__CATG__SMVIEW_CABLE__CONNECTOR"),
            'out_description'     => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_OUT") . " " .  $language->get("LC__CMDB__CATG__SMVIEW_CABLE__DESCRIPTION"),
            'out_scope'           => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_OUT") . " " .$language->get("LC__CMDB__CATG__SMVIEW_CABLE__SCOPE"),
            'out_cable'           => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_OUT") . " " .$language->get("LC__SHD__TELECOMMUNICATION_CABLE"),
            'out_cable_wire'      => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_OUT") . " " .$language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_TITLE"),
            'out_connected_with'  => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_OUT") . " " .$language->get("LC__CMDB__CATG__SMVIEW_CABLE__CONNECTED_WITH"),
            'out_connector_title' => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__TYPE_OUT") . " " .$language->get("LC__CMDB__CATG__SMVIEW_CABLE__CONNECTOR")
        ];
        $property_id = 66203;
        foreach ($cable_pin_properties as $p => $label) {
            $properties[] = ["id" => $property_id, "catg" => "C__CATG__SMVIEW_CABLE_PIN", "const" => "C__CATG__SMVIEW_CABLE_PIN",
                "title" => $label, "special_column" => "true", "key" => $p];
            $property_id++;
        }

        if (class_exists("isys_cmdb_dao_category_g_smview_feed_jira")) {
            // remove 'isys_' from key and add special_column flag
            $props = [];
            foreach ($properties as $p) {
                if ($p['const'] == "C__CATG__SMVIEW_FEED_JIRA" || $p['const'] == "C__CATG__SMVIEW_FEED_VIRTUAL_DEVICE") {
                    $p['key'] = str_replace('isys_', '', $p['key']);
                    $p['special_column'] = "true";
                }
                $props[] = $p;
            }
            $properties = $props;
        }

        $properties[] = ["id" => "65010", "catg" => "136", "const" => "C__SHD__PROFIL", "title" => "Name", "key" => "title", "special_column" => "true"];
        $properties[] = ["id" => "65011", "catg" => "136", "const" => "C__SHD__PROFIL", "title" => "Status", "key" => "status", "special_column" => "true"];
        $properties[] = ["id" => "65012", "catg" => "136", "const" => "C__SHD__PROFIL", "title" => $language->get("LC__MODULE__SMVIEW__STATUS_SERVICES"), "key" => "service_status", "search_disable" => "true", "special_column" => "true"];
        $properties[] = ["id" => "65013", "catg" => "136", "const" => "C__SHD__PROFIL", "title" => "Output", "key" => "output", "special_column" => "true"];

        $properties[] = ["id" => "65020", "catg" => "47", "const" => "C__CATG__IP", "title" => "FQDN", "key" => "fqdn"];

        $properties[] = ["id" => "65030", "catg" => "C__CATS__APPLICATION", "const" => "C__CATS__APPLICATION", "title" => $language->get("LC__CMDB__CATS__APPLICATION_INSTALLATION_COUNT"), "key" => "install_count", "special_column" => "true"];

        $properties[] = ["id" => "65040", "catg" => "C__CATG__CONNECTOR", "const" => "C__CATG__CONNECTOR",
                         "title" => "Hauptobjekt", "key" => "from_object", "special_column" => "true"];
        $properties[] = ["id" => "65041", "catg" => "C__CATG__CONNECTOR", "const" => "C__CATG__CONNECTOR",
                         "title" => "Hauptobjekt Kategorie", "key" => "from_category", "special_column" => "true"];

        $properties[] = ["id" => "65045", "catg" => "C__CATG__CONNECTOR", "const" => "C__CATG__CONNECTOR",
                         "title" => "Gegenstelle Kategorie", "key" => "remote_category", "special_column" => "true"];
        $properties[] = ["id" => "65046", "catg" => "C__CATG__CONNECTOR", "const" => "C__CATG__CONNECTOR",
                         "title" => "Gegenstelle Anschlussart", "key" => "remote_type", "special_column" => "true"];
        $properties[] = ["id" => "65047", "catg" => "C__CATG__CONNECTOR", "const" => "C__CATG__CONNECTOR",
                         "title" => "Gegenstelle Bezeichnung", "key" => "remote_title", "special_column" => "true"];
        $properties[] = ["id" => "65048", "catg" => "C__CATG__CONNECTOR", "const" => "C__CATG__CONNECTOR",
                         "title" => "Gegenstelle Objekt", "key" => "remote_object", "special_column" => "true"];

        $properties[] = ["id" => "65060", "catg" => "C__CATG__LOCATION", "const" => "C__CATG__LOCATION",
                         "title" => "Slot", "key" => "slot", "special_column" => "true"];
        return $properties;
    }

    /**
     * Get all properties of an object type.
     *
     * @param  string $objectTypeConst
     * @return array
     * @throws isys_exception_database
     */
    private function _get_properties_by_object_type_const($objectTypeConst)
    {
        $properties = [];
        $dao = smview_cmdb_dao_category_property::instance($this->m_db);
        $global_dao = new isys_cmdb_dao_category_g_global(isys_application::instance()->database);
        $sql = "SELECT isys_obj_type__id FROM isys_obj_type WHERE isys_obj_type__const = '$objectTypeConst'";
        $row = $global_dao->retrieve($sql)->get_row();
        if (empty($row)) {
            return [];
        }

        $obj_type_id = $row['isys_obj_type__id'];
        $res = $global_dao->get_catg_by_obj_type($obj_type_id);
        while ($row = $res->get_row()) {
            $l_res = $dao->retrieve_properties_shd(null, $row['isysgui_catg__id'], null, null, "", true, null);
            while ($l_data = $l_res->get_row()) {
                $properties[] = $l_data;
            }
        }

        $res = $global_dao->gui_get_cats_by_objtype_id($obj_type_id);
        while ($row = $res->get_row()) {
            $l_res = $dao->retrieve_properties_shd(null, null, $row['isysgui_cats__id'], null, "", true, null);
            while ($l_data = $l_res->get_row()) {
                $properties[] = $l_data;
            }
        }

        $res = $global_dao->gui_get_catg_custom_by_objtype_id($obj_type_id);
        while ($row = $res->get_row()) {
            $l_res = $dao->retrieve_properties_shd(null, null, null, null, "", true, $row['isysgui_catg_custom__id']);
            while ($l_data = $l_res->get_row()) {
                $properties[] = $l_data;
            }
        }
        return $properties;
    }


    /**
     * Get data method. Unused.
     *
     * @return  null
     */
    public function get_data()
    {
        return null;
    }

    private function getBrowser_obj_type($l_data)
    {
        switch ($l_data["const"] . "-" . $l_data["key"]) {
            //Betriebssystem
            case "C__CATG__OPERATING_SYSTEM-application":
                $l_data["browser_obj_types"] = [ (int) defined_or_default('C__OBJTYPE__OPERATING_SYSTEM', 0) => "C__OBJTYPE__OPERATING_SYSTEM" ];
                break;

            case "C__CATG__APPLICATION-assigned_license":
            case "C__CATG__OPERATING_SYSTEM-assigned_license":
                $l_data["browser_obj_types"] = [ (int) defined_or_default('C__OBJTYPE__LICENCE', 0) => "C__OBJTYPE__LICENCE" ];
                break;

            case "C__CATG__APPLICATION-assigned_it_service":
            case "C__CATG__OPERATING_SYSTEM-assigned_it_service":
                $l_data["browser_obj_types"] = [ (int) defined_or_default('C__OBJTYPE__IT_SERVICE', 0) => "C__OBJTYPE__IT_SERVICE" ];
                break;

            //Buchhaltung
            case "C__CATG__ACCOUNTING-contact":
                $l_data["browser_obj_types"] = [
                    (int)defined_or_default('C__OBJECT_TYPE__CUSTOMER', 0) => "C__OBJECT_TYPE__CUSTOMER",
                    (int)defined_or_default('C__OBJTYPE__ORGANIZATION', 0) => "C__OBJTYPE__ORGANIZATION",
                    (int)defined_or_default('C__OBJTYPE__PERSON', 0) => "C__OBJTYPE__PERSON",
                    (int)defined_or_default('C__OBJTYPE__PERSON_GROUP', 0) => "C__OBJTYPE__PERSON_GROUP",
                    (int)defined_or_default('C__OBJECT_TYPE__SYSTEM_ACCOUNT', 0) => "C__OBJECT_TYPE__SYSTEM_ACCOUNT"];
                break;

            case "C__CATG__CMK-parents":
            case "C__CATG__CONTACT-contact":
                $l_data["browser_obj_types"] = [ "-1" => "C__OBJTYPE__ALL" ];
                break;

            case "C__CATG__APPLICATION-application":
                $l_data["browser_obj_types"] = [ (int) defined_or_default('C__OBJTYPE__APPLICATION', 0) => "C__OBJTYPE__APPLICATION" ];
                break;

            case "C__CATG__APPLICATION-assigned_database_schema":
                $l_data["browser_obj_types"] = [ (int) defined_or_default('C__OBJTYPE__DATABASE_SCHEMA', 0) => "C__OBJTYPE__DATABASE_SCHEMA" ];
                break;

                //standort
            case "C__CATG__LOCATION-parent":
                $containedObjects = smview_cmdb_dao_object_type::instance($this->m_db)->get_containerobjects();
                foreach ($containedObjects as $containedObject) {
                    $l_data["browser_obj_types"][$containedObject["isys_obj_type__id"]] =  $containedObject["isys_obj_type__const"];
                }
                break;
        }

        return $l_data;
    }

    /**
     * Get data of dialog properties.
     *
     * @param  array $l_data
     * @param  isys_api_model_shd_dialog_cache_hack $isys_api_model_cmdb_dialog
     * @param  int $status
     * @return array
     * @throws isys_exception_database
     */
    private function getDialog($l_data, $isys_api_model_cmdb_dialog, $status = C__RECORD_STATUS__NORMAL)
    {
        $language = isys_application::instance()->container->get('language');
        $l_data["dialog"] = [];

        if ($l_data["const"] == "C__CATG__VIRTUAL_MACHINE" && $l_data["key"] == "virtual_machine") {
            //bugfix for wrong dialog Fields
            $l_data["dialog"] = [];

            $l_data["dialog"] = [
                ["id" => "-1", "title" => $language->get("LC__MODULE__SMVIEW__NO_VALUE"), "const" => ""],
                ["id" => "-99", "title" => "-", "const" => ""],
                ["id" => "3", "const" => "3", "title" => $language->get("LC__CMDB__CATG__VIRTUAL_NO")],
                ["id" => "2", "const" => "2", "title" => $language->get("LC__CMDB__CATG__VIRTUAL_MACHINE")]

            ];
        } else {
            $array = ["category" => $l_data["const"], "property" => $l_data["key"], "status" => $status];
            try {
                $dialogArray = $isys_api_model_cmdb_dialog->read($array);
                if ($dialogArray != []) {
                    $r_dialog = [];
                    if (! ($l_data["const"] == "C__CATG__GLOBAL" && $l_data["key"] == "cmdb_status")) {
                        $r_dialog[] = ["id" => "-1", "title" => $language->get("LC__MODULE__SMVIEW__NO_VALUE"), "const" => ""];
                        $r_dialog[] = ["id" => "-99", "title" => "-", "const" => ""];
                    }

                    $l_dialog = $dialogArray;
                    if (isset($l_dialog[0]["id"])){
                        foreach ($l_dialog as $item) {
                            $r_dialog[] = $item;
                        }
                    } else {
                        foreach ($l_dialog[0] as $item) {
                            $r_dialog[] = $item;
                        }
                    }
                    $l_data["dialog"] = $r_dialog;
                }
            } catch (isys_exception $ex) {
            }
        }

        if (class_exists("isys_cmdb_dao_smview_cable_group") == true) {
            if ($l_data["const"] == "C__CATG__SMVIEW_CABLE" && $l_data["key"] == "state_id") {
                $l_dialog = $this->getBaseDialog();
                $dao = new isys_cmdb_dao_smview_cable_user_state($this->m_db);
                $group = $dao->get_data();
                foreach ($group as $item) {
                    $name = $item["name"] . ': ' . $item["description"];
                    $l_dialog[] = ["id" => $item["id"], "title" => $name, "const" => $name];
                }
                $l_data["dialog"] = $l_dialog;
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE" && $l_data["key"] == "group_id") {
                $dao = new isys_cmdb_dao_smview_cable_group($this->m_db);
                $l_data["dialog"] = $this->_getDialogByDao($dao);
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE" && $l_data["key"] == "admin_unit") {
                $dao = new isys_cmdb_dao_smview_cable_admin_unit($this->m_db);
                $l_data["dialog"] = $this->_getDialogByDao($dao);
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE" && $l_data["key"] == "type_id") {
                $dao = new isys_cmdb_dao_smview_cable_type($this->m_db);
                $l_data["dialog"] = $this->_getDialogByDao($dao);
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE" && $l_data["key"] == "is_section_cable") {
                $l_dialog = [
                    ["id" => "0", "title" => $language->get("LC__UNIVERSAL__NO"), "const" => ""],
                    ["id" => "1", "title" => $language->get("LC__UNIVERSAL__YES"), "const" => ""]
                ];
                $l_data["dialog"] = $l_dialog;
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE" && $l_data["key"] == "connection_type_id") {
                $dao = new isys_cmdb_dao_smview_cable_connection_type($this->m_db);
                $l_data["dialog"] = $this->_getDialogByDao($dao);
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE_WIRE" && $l_data["key"] == "user_state_id") {
                $l_dialog = $this->getBaseDialog();
                $dao = new isys_cmdb_dao_smview_cable_user_state($this->m_db);
                $group = $dao->get_raw_user_state();

                while ($l_group = $group->get_row()) {
                    $l_dialog[] = ["id" => $l_group["id"], "title" => $l_group["name"], "const" => $l_group["description"]];
                }
                $l_data["dialog"] = $l_dialog;
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE_WIRE" && $l_data["key"] == "state_out") {
                $l_dialog = $this->getBaseDialog();
                $states = isys_cmdb_dao_smview_cable_wire_pin::get_wire_states();
                foreach ($states as $id => $const) {
                    $l_dialog[] = ["id" => $id, "title" => $const, "const" => $const];
                }
                $l_data["dialog"] = $l_dialog;
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE_WIRE" && $l_data["key"] == "state_in") {
                $l_dialog = $this->getBaseDialog();
                $states = isys_cmdb_dao_smview_cable_wire_pin::get_wire_states();
                foreach ($states as $id => $const) {
                    $l_dialog[] = ["id" => $id, "title" => $const, "const" => $const];
                }
                $l_data["dialog"] = $l_dialog;
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE_WIRE" && $l_data["key"] == "reserved") {
                $l_dialog = [
                    ["id" => "-1", "title" => $language->get("LC__MODULE__SMVIEW__NO_VALUE"), "const" => ""],
                    ["id" => "-99", "title" => "-", "const" => ""],

                    ["id" => "0", "title" => $language->get("LC__UNIVERSAL__NO"), "const" => ""],
                    ["id" => "1", "title" => $language->get("LC__UNIVERSAL__YES"), "const" => ""]
                ];
                $l_data["dialog"] = $l_dialog;
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE_WIRE" && $l_data["key"] == "in_use") {
                $l_dialog = [
                    ["id" => "-1", "title" => $language->get("LC__MODULE__SMVIEW__NO_VALUE"), "const" => ""],
                    ["id" => "-99", "title" => "-", "const" => ""],

                    ["id" => "0", "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_IS_WIRED"), "const" => ""],
                    ["id" => "1", "title" => $language->get("LC__CMDB__CATG__SMVIEW_CABLE__WIRE_IS_DISPOSED"), "const" => ""]
                ];
                $l_data["dialog"] = $l_dialog;
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE_WIRE" && $l_data["key"] == "connection_type_id") {
                $dao = new isys_cmdb_dao_smview_cable_connection_type($this->m_db);
                $l_data["dialog"] = $this->_getDialogByDao($dao, "name");
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE_SECTION" && $l_data["key"] == "user_state_id") {
                $l_dialog = $this->getBaseDialog();
                $dao = new isys_cmdb_dao_smview_cable_user_state($this->m_db);
                $group = $dao->get_data();
                foreach ($group as $item) {
                    $name = $item["name"] . ': ' . $item["description"];
                    $l_dialog[] = ["id" => $item["id"], "title" => $name, "const" => $name];
                }
                $l_data["dialog"] = $l_dialog;
            } elseif (($l_data["const"] == "C__CATG__SMVIEW_CABLE_ROUTE" || $l_data["const"] == "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE") && $l_data["key"] == "route_usage_id") {
                $usage_dao = new isys_cmdb_dao_smview_cable_route_usage($this->m_db);
                $l_data["dialog"] = $this->_getDialogByDao($usage_dao, 'name', 'technology');
            } elseif (($l_data["const"] == "C__CATG__SMVIEW_CABLE_ROUTE" || $l_data["const"] == "C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE") && $l_data["key"] == "is_external") {
                $l_dialog = [
                    ["id" => "0", "title" => $language->get("LC__UNIVERSAL__NO"), "const" => ""],
                    ["id" => "1", "title" => $language->get("LC__UNIVERSAL__YES"), "const" => ""]
                ];
                $l_data["dialog"] = $l_dialog;
            } elseif ($l_data["const"] == "C__CATG__SMVIEW_CABLE_ROUTE" && $l_data["key"] == "is_rented") {
                $l_dialog = [
                    ["id" => "0", "title" => $language->get("LC__UNIVERSAL__NO"), "const" => ""],
                    ["id" => "1", "title" => $language->get("LC__UNIVERSAL__YES"), "const" => ""]
                ];
                $l_data["dialog"] = $l_dialog;
            }
        }

        if (class_exists("isys_cmdb_dao_smview_cable_group") == true) {
            if ($l_data["const"] == "C__CATG__SMVIEW_PATCH_FORMFACTOR" && $l_data["key"] == "half_he") {
                $l_dialog = [
                    ["id" => "-1", "title" => $language->get("LC__MODULE__SMVIEW__NO_VALUE"), "const" => ""],
                    ["id" => "-99", "title" => "-", "const" => ""],
                    ["id" => "0", "title" => $language->get("LC__UNIVERSAL__NO"), "const" => ""],
                    ["id" => "1", "title" => $language->get("LC__UNIVERSAL__YES"), "const" => ""]
                ];
                $l_data["dialog"] = $l_dialog;
            }
        }

        $l_data["dialog"] = $this->sort_dialog($l_data["dialog"]);

        return $l_data;
    }

    private function getBaseDialog()
    {
        $language = isys_application::instance()->container->get('language');
        return [
            ["id" => "-1", "title" => $language->get("LC__MODULE__SMVIEW__NO_VALUE"), "const" => ""],
            ["id" => "-99", "title" => "-", "const" => ""]
        ];
    }

    private function _getDialogByDao($dao, $nameProperty = "description", $secondNameProperty = null)
    {
        $l_dialog = $this->getBaseDialog();
        $data = $dao->get_data();
        foreach ($data as $item) {
            $title = $item[$nameProperty];
            if (isset($secondNameProperty) && ! empty($item[$secondNameProperty])) {
                $title .= ' (' . $item[$secondNameProperty] . ')';
            }
            $l_dialog[] = [
                "id"    => $item["id"],
                "title" => $title,
                "const" => $item[$nameProperty]
            ];
        }
        return $l_dialog;
    }

    private function getValidationData()
    {
        $sql = "SELECT * FROM isys_validation_config ";
        $data = $this->retrieve($sql);

        while ($l_row = $data->get_row()) {
            $this->m_validation[$l_row["isys_validation_config__isysgui_catg__id"]] = $l_row;
            $this->m_validation[$l_row["isys_validation_config__isysgui_catg__id"]]["isys_validation_config__json"] =
                json_decode($this->m_validation[$l_row["isys_validation_config__isysgui_catg__id"]]["isys_validation_config__json"], true);
        }
    }

    private function getMandatory($const, $key)
    {
        //check const isset in validation
        if (isset($this->m_validation[$const])) {
            if (isset($this->m_validation[$const]["isys_validation_config__json"][$key]["check"]["mandatory"])) {
                return $this->m_validation[$const]["isys_validation_config__json"][$key]["check"]["mandatory"];
            }
        }
        return false;
    }

    private function sort_dialog($l_dialog)
    {
        $baseDialog = [];
        if (count($l_dialog) >= 2 && $l_dialog[0]['id'] == '-1' && $l_dialog[1]['id'] == '-99') {
            $baseDialog = [
                array_shift($l_dialog),
                array_shift($l_dialog),
            ];
        }
        usort($l_dialog, function ($a, $b) {
            return strcasecmp(strval($a['title']), strval($b['title']));
        });
        return array_merge($baseDialog, $l_dialog);
    }
}


/*
 * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 *
 * Sorry fuer diesen verrueckten inline-class hack.
 * Aber um hier mehr Schwung reinzubekommen ohne den Rest kaputt zu machen muss ich hier diese
 * Klasse einbauen und relevante Methoden anpassen.
 *
 * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 */


class isys_api_model_shd_dialog_cache_hack extends isys_api_model_cmdb_dialog
{

    /**
     * Local cache of category properties.
     *
     * @var array
     */
    private $m_categoryProperties = [];

    /**
     * Logger.
     *
     * @var isys_log
     */
    private $logger;

    /**
     * isys_api_model_cmdb_dialog constructor.
     *
     * @param isys_cmdb_dao $p_dao
     */
    public function __construct(isys_cmdb_dao $p_dao)
    {
        global $g_absdir;

        parent::__construct($p_dao);

        $this->logger = isys_log::get_instance('shd-smview')->set_log_file($g_absdir . '/log/shd-smview_' . date('Y-m-d') . '.log');
    }

    /**
     * Read category data.
     *
     * Parameter structure:
     *    [
     *       'property' => 'manufacturer' | array('title', 'manufacturer),
     *       'category' => 'C__CATG__CPU'
     *    ]
     *
     * @param array $params
     *
     * @return array|bool
     * @throws isys_exception_api
     * @throws isys_exception_auth
     * @throws isys_exception_database
     */
    public function read($params)
    {
        $properties = $params["property"];

        if (!is_array($properties))
        {
            $properties = [$properties];
        }

        /**
         * Get DAO class
         *
         * @var isys_cmdb_dao_category
         */
        $categoryDao = self::get_dao_class($params);

        /**
         * Get translation object
         */
        $language = isys_application::instance()->container->get('language');

        /* Process data */
        if ($categoryDao)
        {
            /*
             * Modified to use internal cache
             */
            $catConst = $params['category'];
            if (! $this->m_categoryProperties[$catConst]) {
                $daoProperties = $categoryDao->get_properties();
                $this->m_categoryProperties[$catConst] = $daoProperties;
            }
            $daoProperties = $this->m_categoryProperties[$catConst];
            /*
             * /Modified
             */

            $response      = [];

            if (!is_array($daoProperties) || count($properties) === 0)
            {
                throw new isys_exception_api("You have to deliver at least one property parameter.");
            }

            foreach ($properties AS $property)
            {
                if (! isset($daoProperties[$property]))
                {
                    continue;
                }

                $properties = $daoProperties[$property];

                if ($properties["ui"]["type"] != 'dialog' && $properties[C__PROPERTY__UI][C__PROPERTY__UI__PARAMS]['p_strPopupType'] != "dialog_plus")
                {
                    continue;
                }

                if ($property == 'software_assignment' && get_class($categoryDao) == 'isys_cmdb_dao_category_g_cmk_host_service') {
                    // ignore this property to avoid memory-limit-error (MDK-BB)
                    continue;
                }

                // @see  API-41
                if ($categoryDao instanceof isys_cmdb_dao_category_g_custom_fields)
                {
                    $identifier = $properties['ui']['params']['identifier'];

                    $l_dao = new isys_cmdb_dao_dialog_admin($this->m_dao->get_database_component());
                    $table = 'isys_dialog_plus_custom';

//                    if ($this->useAuth)
//                    {
//                        isys_auth_dialog_admin::instance()
//                            ->custom(isys_auth::VIEW, $identifier);
//                    }

                    $l_res = $l_dao->get_data($table, null, 'isys_dialog_plus_custom__identifier = ' . $l_dao->convert_sql_text($identifier));
                }
                else
                {
                    if (isset($properties[C__PROPERTY__UI][C__PROPERTY__UI__PARAMS]['p_arData'])) {
                        $propertyArData = $properties[C__PROPERTY__UI][C__PROPERTY__UI__PARAMS]['p_arData'];
                        if ($propertyArData instanceof isys_callback) {
                            $l_res = $propertyArData->execute();
                        } elseif (is_array($propertyArData)) {
                            $l_res = $propertyArData;
                        }
                        $data = array();
                        foreach ($l_res as $id => $stringValue) {
                            if (is_string($stringValue) && stripos($stringValue, 'LC_') === 0) {
                                $title = $language->get($stringValue);
                            } else {
                                $title = $stringValue;
                            }
                            $data[] = array(
                                'id' => $id,
                                'const' => null,
                                'title' => $title,
                            );
                        }
                        $response[] = $data;
                        return $response;
                    }

                    $condition = null;

                    if (!isset($params['ignoreCondition']) || !$params['ignoreCondition'])
                    {
                        if (isset($properties[C__PROPERTY__UI][C__PROPERTY__UI__PARAMS]["condition"]))
                        {
                            $condition = $properties[C__PROPERTY__UI][C__PROPERTY__UI__PARAMS]["condition"];
                        }
                    }

                    $l_dao = new isys_cmdb_dao_dialog_admin($this->m_dao->get_database_component());
                    $table = $properties[C__PROPERTY__UI][C__PROPERTY__UI__PARAMS]["p_strTable"];

//                    if ($this->useAuth)
//                    {
//                        isys_auth_dialog_admin::instance()
//                            ->table(isys_auth::VIEW, $table);
//                    }

                    try {
                        $l_res = $l_dao->get_data($properties[C__PROPERTY__UI][C__PROPERTY__UI__PARAMS]["p_strTable"], null, $condition);
                    } catch (Exception $e) {
                        $propertyId = get_class($categoryDao) . " - $property";
                        $this->logger->warning(__METHOD__ . " --> can not read property '$propertyId': " . $e->getMessage());
                        continue;
                    }
                }

                if ($l_res->num_rows())
                {
                    /**
                     * @see API-32 Consider parent table
                     */
                    $parentTable = $l_dao->get_parent_table($properties[C__PROPERTY__UI][C__PROPERTY__UI__PARAMS]["p_strTable"]);

                    while ($l_row = $l_res->get_row()) {

                        if (! empty($params['status']) && $params['status'] != $l_row[$table . "__status"]) {
                            continue;
                        }

                        // Setup general data values
                        $data = [
                            "id"    => $l_row[$table . "__id"],
                            "const" => isset($l_row[$table . "__const"]) ? $l_row[$table . "__const"] : '',
                            "title" => _L($l_row[$table . "__title"]),
                        ];

                        // Handle parentTable relation of entry if needed
                        if ($parentTable) {
                            $data['parent'] = [
                                'id'    => $l_row[$parentTable . '__id'],
                                'const' => isset($l_row[$$parentTable . "__const"]) ? $l_row[$parentTable . "__const"] : '',
                                'title' => _L($l_row[$parentTable . '__title'])
                            ];
                        }

                        // Persist entry in response
                        $response[] = $data;
                    }
                }
            }

            return $response;
        }

        return false;
    }

    /**
     * Retrieve the category dao by given Parameter.
     *
     * @param   array          $p_params
     *
     * @return  bool|isys_cmdb_dao_category
     * @throws  isys_exception_api
     * @throws  isys_exception_database
     */
    private static function get_dao_class($p_params)
    {
        $l_dao = new isys_cmdb_dao(isys_application::instance()->database);

        // Process Parameters.
        if (@$p_params[C__CMDB__GET__CATS])
        {
            $l_get_param  = C__CMDB__GET__CATS;
            $l_cat_suffix = 's';
        }
        else if (@$p_params[C__CMDB__GET__CATG])
        {
            $l_get_param  = C__CMDB__GET__CATG;
            $l_cat_suffix = 'g';
        }
        else if (isset($p_params['category']) && is_string($p_params['category']))
        {
            if (strpos($p_params['category'], 'C__CATG__CUSTOM_FIELDS_') !== false && defined($p_params['category'])) {
                $dao = new isys_cmdb_dao_category_g_custom_fields($l_dao->get_database_component());

                $dao->set_catg_custom_id(defined_or_default($p_params['category']));

                return $dao;
            }

            if (strstr($p_params['category'], 'C__CATG'))
            {
                $l_cat_suffix = 'g';
            }
            else
            {
                $l_cat_suffix = 's';
            }

            $l_get_param = 'category';
        }
        else
        {
            throw new isys_exception_api(
                'Category ID missing. You must specify the parameter \'catsID\' or \'catgID\' ' .
                'in order to identify the corresponding category you would like to read data from.', -32602
            );
        }

        // Get category info.
        if (is_numeric(addslashes($p_params[$l_get_param])))
        {
            $l_isysgui = $l_dao->get_isysgui('isysgui_cat' . $l_cat_suffix, (int) $p_params[$l_get_param])
                ->__to_array();
        }
        else
        {
            $l_isysgui = $l_dao->get_isysgui('isysgui_cat' . $l_cat_suffix, null, null, addslashes($p_params[$l_get_param]))
                ->__to_array();
        }

        // Check class and instantiate it.
        if (class_exists($l_isysgui["isysgui_cat{$l_cat_suffix}__class_name"]))
        {
            /* Process data */
            if (($l_cat = new $l_isysgui["isysgui_cat{$l_cat_suffix}__class_name"]($l_dao->get_database_component())))
            {
                return $l_cat;
            }
        }

        return false;
    }
}
