<?php

/**
 * Activate API controller.
 *
 * @package i-doit
 * @subpackage livestatus
 * @author Steve Groeber <steve.groeber@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 * @license http://www.i-doit.com/license
 */
class isys_handler_smview_activate_api extends isys_handler {
    
    /**
     * Initialization method.
     * 
     * You can call this controller via CLI from i-doit root:
     * sudo -u www-data ./controller -v -d -u admin -p admin -i 1 -m smview_activate_api
     *
     * @return  boolean
     */
    public function init() {
        verbose("start\n");
        
        global $g_absdir, $argv;
        $keyFile = $g_absdir . '/images/shd-smview.fdg';
        $mandator__id = count($argv) == 2 ? (int) $argv[1] : 1;
        
        $l_apikey_data = isys_application::instance()->database_system->fetch_row_assoc(
            isys_application::instance()->database_system->query(
                'SELECT isys_mandator__apikey, isys_mandator__title FROM isys_mandator 
                  WHERE isys_mandator__id = "' . $mandator__id . '";'
            )
        );
        
        $apititle = $l_apikey_data["isys_mandator__title"];
        $apikey = $l_apikey_data["isys_mandator__apikey"];
        
        if (empty($apikey)) {
            $apikey = $this->_generate_api_key();
            $db = isys_application::instance()->database_system;
            $l_update = 'UPDATE isys_mandator SET isys_mandator__apikey = "' . $apikey . '" '
                 . 'WHERE isys_mandator__id = "' . $mandator__id . '";';
            if ($db->query($l_update) && $db->commit()) {
                verbose('created new api key');
            }
        }
        
        $apiarray = array();
        if (file_exists($keyFile)) {
            // get current content
            $apikeyString = file_get_contents($keyFile);
            $apiarray = json_decode(base64_decode($apikeyString),true);
        }
        
        // set mandator data
        $apiarray[$mandator__id]["title"] = $apititle;
        $apiarray[$mandator__id]["apikey"] = $apikey;
        
        // save to file
        $ifp = fopen($keyFile, "wb" );
        fwrite( $ifp, base64_encode( json_encode( $apiarray ) ) );
        fclose( $ifp );
        
        verbose("finished\n");
    }
    
    /**
     * Generate a random API key.
     * 
     * @return string
     */
    private function _generate_api_key() {
        $characters = 'abcdefghijklmnopqrstuvwxyz0123456789';
        $string = '';
        $max = strlen($characters) - 1;
        for ($i = 0; $i < 10; $i++) {
             $string .= $characters[mt_rand(0, $max)];
        }
        return $string;
    }
}
