<?php

/**
 * Module updater to automatically update modules via zip file.
 * 
 * @package    idoit
 * @subpackage smview
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2019 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license MIT
 */
class isys_handler_smview_update_modules extends isys_handler {

    /**
     * Initialization method.
     *
     * You can call this controller via CLI from i-doit root:
     * sudo -u www-data /var/www/html/i-doit/controller -v -d -u <USER> -p <PASSWORD> -i <TENANT-ID> -m smview_update_modules
     *
     * @return  boolean
     */
    public function init() {
        $updater = new idoit\Module\Smview\ModuleUpdater(true);
        $modules = $updater->getAvailableModules();
        $updater->update(array_values($modules));
    }
}
