<?php
/**
 * i-doit
 *
 * Module initializer
 *
 * @package     i-doit
 * @subpackage  Modules
 * @author      Dennis Stücken <dstuecken@i-doit.com>
 * @version     1.1
 * @copyright   synetics GmbH
 * @license     http://www.i-doit.com/license
 */
if (isys_module_manager::instance()->is_active('smview'))
{

    /* Initialize autoloader*/
    if (include_once('isys_module_smview_autoload.class.php'))
    {
        spl_autoload_register('isys_module_smview_autoload::init');
    }

    \idoit\Psr4AutoloaderClass::factory()
        ->addNamespace('idoit\Module\smview', __DIR__ . '/src/');

    /** Initialize initslots.
     *
     * @NOTE THAT THIS IS NOT NEEDED IF MODULE IS SUCCESSFULLY INSTALLED AND ACTIVATED
     */


    /* Append custom module language file */
    global $g_idoit_language_short, $g_comp_signals, $g_comp_database, $g_comp_template;


    $files = scandir(__DIR__ . "/..");
    foreach($files as $file) {

        $lang_path = __DIR__ . "/../" . $file;
        $lang_file = __DIR__ . "/../" . $file . DS . 'lang' . DS . $g_idoit_language_short . '.inc.php';
        if(is_dir($lang_path) == false || ($file == ".." || $file == "." ) ) {
            continue;
        }

//        if (is_dir($lang_path) && file_exists($lang_file)) {
        if (file_exists($lang_file)) {
            $l_language = include_once $lang_file;

            if (is_array($l_language)) {
                global $g_comp_template_language_manager;
                $g_comp_template_language_manager->append_lang($l_language);
            }
        }
    }

    // Make controller class available
    $GLOBALS['g_controller']['handler']['smview_activate_api'] = ['class' => 'isys_handler_smview_activate_api'];
    $GLOBALS['g_controller']['handler']['smview_license_installation'] = ['class' => 'isys_handler_smview_license_installation'];
    $GLOBALS['g_controller']['handler']['smview_test_data_generator'] = ['class' => 'isys_handler_smview_test_data_generator'];
    $GLOBALS['g_controller']['handler']['smview_update_modules'] = ['class' => 'isys_handler_smview_update_modules'];
}
