<?php

//Added Global Const
define('C__OBJTYPE__ALL', 0);

/**
 * i-doit
 *
 * Class autoloader.
 *
 * @package i-doit
 * @subpackage smview client
 * @author Maik Rhode <maik.rhode@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 * @license http://www.i-doit.com/license
 */
class isys_module_smview_autoload extends isys_module_manager_autoload
{
    /**
     * Autoloader
     *
     * @return boolean
     * @param string $p_classname
     */
    public static function init($p_classname)
    {
        $class_loader_paths = array(
            '/api/model/',
            '/api/model/shd/',
            '/cmdb/dao/',
            '/cache/',
            '/handler/controller/',
        );

        try {
            //dynamic loading of classes
            foreach ($class_loader_paths as $clp) {
                if (! file_exists(__DIR__ . $clp . $p_classname . '.class.php')) {
                    continue;
                }
                $l_path = __DIR__ . $clp . $p_classname . '.class.php';
                if (include_once($l_path)) {
                    isys_caching::factory('autoload')->set($p_classname, $l_path);
                    return true;
                }
            }
        } catch (Exception $e) {
            throw $e;
        }

        try {
            //dynamic loading of classes
            if( $p_classname  == 'isys_auth_smview' ) {
                $l_path = __DIR__ . '/auth/' . $p_classname . '.class.php';
                if (include_once($l_path)) {
                    isys_caching::factory('autoload')->set($p_classname, $l_path);
                    return true;
                }
            }
        } catch (Exception $e) {
            throw $e;
        }
        
        // single classes
        $l_classes = [
            'isys_ajax_handler_smview_updater'                               => __DIR__ . '/handler/ajax/isys_ajax_handler_smview_updater.class.php',
            'idoit\Module\Smview\ModuleUpdater'                              => __DIR__ . '/src/ModuleUpdater.php',
            'idoit\Module\Smview\Console\Command\ActivateApiCommand'         => __DIR__ . '/src/Console/Command/ActivateApiCommand.php',
            'idoit\Module\Smview\Console\Command\LicenseInstallationCommand' => __DIR__ . '/src/Console/Command/LicenseInstallationCommand.php',
            'idoit\Module\Smview\Console\Command\TestDataGeneratorCommand'   => __DIR__ . '/src/Console/Command/TestDataGeneratorCommand.php',
            'idoit\Module\Smview\Console\Command\UpdateModulesCommand'       => __DIR__ . '/src/Console/Command/UpdateModulesCommand.php',
        ];
        
        if (isset($l_classes[$p_classname])) {
            if (include_once($l_classes[$p_classname])) {
                isys_caching::factory('autoload')->set($p_classname, $l_classes[$p_classname]);
                return true;
            }
        }
        return false;
    }
}
