<?php

/**
 * i-doit
 *
 * JSON-RPC Test case
 *
 * @author     Dennis Stücken <dstuecken@i-doit.org>
 * @author     Benjamin Heisig <bheisig@synetics.de>
 * @package    i-doit
 * @subpackage UnitTesting
 * @copyright  synetics GmbH
 * @license    http://www.i-doit.com/license
 */

/** Include JSON-RPC client. */
global $g_absdir;
//include_once '/var/www/html/i-doit/src/tests/jsonrpc.class.php';
include_once '/var/www/html/i-doit/src/classes/modules/smview/tests/jsonrpc.php';
use PHPUnit\Framework\TestCase;

/**
 * Test class for isys_api_controller_jsonrpc
 */
class test_api_categories extends TestCase
{

    private $m_client;

    private $m_session;

    public function test_create()
    {
        global $g_test_config;

        $id[0] = 1372;

        $l_params = [
            'session' => $this->m_session,
            'id'      => '1',
            'apikey' => $this->m_apikey,
            'condition' => [["comparison"=>"=","property"=>"C__CATG__GLOBAL-id", "category"=> "C__CATG__GLOBAL","value"=> $id[0]]],
            'columns' => [["id"=>"C__CATG__GLOBAL-title","width"=>"140", "sort"=> ""],["id"=>"C__CATG__GLOBAL-description","width"=>"140", "sort"=> ""],["id"=>"C__CATG__GLOBAL-cmdb_status","width"=>"140", "sort"=> ""]
                ,["id"=>"C__CATG__GLOBAL-cmdb_status","width"=>"140", "sort"=> ""]],
            'obj_type_id' => '5'
        ];

        $l_result = $this->m_client->__call('shd.query.category', $l_params);

        print_r($l_result);

//        {"method":"shd.query.category","id":"1","params":{"display_rows":"50","condition":[{"comparison":"=","property":"C__CATG__GLOBAL-id","category":"C__CATG__GLOBAL","value":"1372"}],"apikey":"365478025",
//"columns":[{"width":"140","id":"C__CATG__GLOBAL-description","sort":""},{"width":"140","id":"C__CATG__GLOBAL-title","sort":""},{"width":"140","id":"C__CATG__GLOBAL-cmdb_status","sort":""},
//{"width":"140","id":"C__CATG__GLOBAL-purpose","sort":""},{"width":"140","id":"C__CATG__GLOBAL-created_by","sort":""},{"width":"140","id":"C__CATG__GLOBAL-created","sort":""},
//{"width":"140","id":"C__CATG__GLOBAL-id","sort":""},{"width":"140","id":"C__CATG__GLOBAL-category","sort":""},{"width":"140","id":"C__CATG__GLOBAL-changed","sort":""},
//{"width":"140","id":"C__CATG__GLOBAL-changed_by","sort":""},{"width":"140","id":"C__CATG__GLOBAL-type","sort":""},{"width":"140","id":"C__CATG__GLOBAL-type_group_title","sort":""},
//{"width":"140","id":"C__CATG__GLOBAL-group_image","sort":""},{"width":"140","id":"C__CATG__GLOBAL-sysid","sort":""},{"width":"140","id":"C__CATG__GLOBAL-tag","sort":""}],"language":"de","page":"0"},"jsonrpc":"2.0"}



        $this->assertInternalType('array', $l_result);

        //there are 15 properties in Global
//        $this->assertEquals(15, $i_check_Categorys);


    }


//    public function test_read()
//    {
//        global $g_test_config;
//
//        $l_params = [
//            'session' => $this->m_session,
//            'id'      => '1',
//            'apikey' => '365478025',
//            'with_dialog' => true
//        ];
//
//        $l_result = $this->m_client->__call('shd.properties', $l_params);
//
//        $i_check_Categorys = 0;
//
//        foreach ($l_result as $item) {
//            if($item["const"] == "C__CATG__GLOBAL") {
//                $i_check_Categorys += 1;
//            }
//        }
//
//
//        $this->assertInternalType('array', $l_result);
//
//        //there are 15 properties in Global
//        $this->assertEquals(15, $i_check_Categorys);
//
//
//    }
//
//    public function test_update()
//    {
//        global $g_test_config;
//
//        $l_params = [
//            'session' => $this->m_session,
//            'id'      => '1',
//            'apikey' => '365478025',
//            'with_dialog' => true
//        ];
//
//        $l_result = $this->m_client->__call('shd.properties', $l_params);
//
//        $i_check_Categorys = 0;
//
//        foreach ($l_result as $item) {
//            if($item["const"] == "C__CATG__GLOBAL") {
//                $i_check_Categorys += 1;
//            }
//        }
//
//
//        $this->assertInternalType('array', $l_result);
//
//        //there are 15 properties in Global
//        $this->assertEquals(15, $i_check_Categorys);
//
//
//    }
//
//    public function test_delete()
//    {
//        global $g_test_config;
//
//        $l_params = [
//            'session' => $this->m_session,
//            'id'      => '1',
//            'apikey' => '365478025',
//            'with_dialog' => true
//        ];
//
//        $l_result = $this->m_client->__call('shd.properties', $l_params);
//
//        $i_check_Categorys = 0;
//
//        foreach ($l_result as $item) {
//            if($item["const"] == "C__CATG__GLOBAL") {
//                $i_check_Categorys += 1;
//            }
//        }
//
//
//        $this->assertInternalType('array', $l_result);
//
//        //there are 15 properties in Global
//        $this->assertEquals(15, $i_check_Categorys);
//
//
//    }

//
//    /**
//     * Sets up the fixture, for example, opens a network connection.
//     * This method is called before a test is executed.
//     */
    protected function setUp(): void {
        global $g_test_config;

        // Login required:
        $this->m_session = $g_test_config['session'];

//        $l_url = $g_test_config['path']['url'] . 'https://mrh-sma.shd-online.de/i-doit/src/jsonrpc.php';

        $l_url = 'https://mrh-sma.shd-online.de/i-doit/src/jsonrpc.php';

        $l_debug = $g_test_config['debug']['var_dump'];

        $this->m_client = new isys_json_rpc($l_url, $l_debug);

        $this->m_client->setRPCAuth('admin', 'admin');

        $this->m_apikey = '365478025';
    }

}

?>
