<?php

/**
 * i-doit
 *
 * JSON-RPC Test case
 *
 * @author     Dennis Stücken <dstuecken@i-doit.org>
 * @author     Benjamin Heisig <bheisig@synetics.de>
 * @package    i-doit
 * @subpackage UnitTesting
 * @copyright  synetics GmbH
 * @license    http://www.i-doit.com/license
 */

/** Include JSON-RPC client. */
global $g_absdir;
//include_once '/var/www/html/i-doit/src/tests/jsonrpc.class.php';
include_once '/var/www/html/i-doit/src/classes/modules/smview/tests/jsonrpc.php';
use PHPUnit\Framework\TestCase;

/**
 * Test class for isys_api_controller_jsonrpc
 */
class test_api_properties extends TestCase
{

    private $m_client;

    private $m_session;

    public function test_index()
    {
        global $g_test_config;

        $min_count = false;

        $l_params = [
            'session' => $this->m_session,
            'id'      => '1',
            'apikey' => '365478025'
        ];

        $l_result = $this->m_client->__call('shd.properties', $l_params);

        $i_check_Categorys = 0;

        foreach ($l_result as $item) {
            if($item["const"] == "C__CATG__GLOBAL") {
                $i_check_Categorys += 1;
            }
        }

        //Prüft ob er mehr als 1000 Eigenschaften findet
        //Wenn nicht gibt es in der Datenbank fehler
        if(count($l_result) > 1000) {
            $min_count = true;
        }


        $this->assertInternalType('array', $l_result);

        //there are 15 properties in Global
        $this->assertEquals(15, $i_check_Categorys);
        $this->assertEquals(true, $min_count);


    }


    public function test_with_dialog()
    {
        global $g_test_config;

        $l_params = [
            'session' => $this->m_session,
            'id'      => '1',
            'apikey' => '365478025',
            'with_dialog' => true
        ];

        $l_result = $this->m_client->__call('shd.properties', $l_params);

        $i_check_Categorys = 0;

        foreach ($l_result as $item) {
            if($item["const"] == "C__CATG__GLOBAL") {
                $i_check_Categorys += 1;
            }
        }


        $this->assertInternalType('array', $l_result);

        //there are 15 properties in Global
        $this->assertEquals(15, $i_check_Categorys);


    }


//    /**
//     * Sets up the fixture, for example, opens a network connection.
//     * This method is called before a test is executed.
//     */
    protected function setUp() : void
    {
        global $g_test_config;

        // Login required:
        $this->m_session = $g_test_config['session'];

//        $l_url = $g_test_config['path']['url'] . 'https://mrh-sma.shd-online.de/i-doit/src/jsonrpc.php';

        $l_url = 'https://mrh-sma.shd-online.de/i-doit/src/jsonrpc.php';

        $l_debug = $g_test_config['debug']['var_dump'];

        $this->m_client = new isys_json_rpc($l_url, $l_debug);


        $this->m_client->setRPCAuth('admin', 'admin');
    }
//
//    /**
//     * Tears down the fixture, for example, closes a network connection.
//     * This method is called after a test is executed.
//     */
//    protected function tearDown()
//    {
//    }

}

?>
