<?php

/**
 * i-doit
 *
 * JSON-RPC Test case
 *
 * @author     Dennis Stücken <dstuecken@i-doit.org>
 * @author     Benjamin Heisig <bheisig@synetics.de>
 * @package    i-doit
 * @subpackage UnitTesting
 * @copyright  synetics GmbH
 * @license    http://www.i-doit.com/license
 */

/** Include JSON-RPC client. */
global $g_absdir;
//include_once '/var/www/html/i-doit/src/tests/jsonrpc.class.php';
include_once '/var/www/html/i-doit/src/classes/modules/smview/tests/jsonrpc.php';
use PHPUnit\Framework\TestCase;

/**
 * Test class for isys_api_controller_jsonrpc
 */
class test_api_properties_Global extends TestCase
{

    private $m_client;

    private $m_session;

    public function test_create_object()
    {

        $l_params = [
            'apikey'  => $this->m_apikey,
            'objects' => [
                ['C__CATG__GLOBAL-title' => 'test_api_call','C__CATG__GLOBAL-cmdb_status' => 'In Betrieb']


            ],
            'obj_type_id' => '5'
        ];

        $l_result = $this->m_client->__call('shd.objects.create', $l_params);

        $this->assertEquals('objects.create.success', $l_result["message"]);

        $this->assertInternalType('array', $l_result);

        //there are 15 properties in Global
//        $this->assertEquals(15, $i_check_Categorys);


        foreach ($l_result["response"][0] as $item) {

            return $item;
        }

        $this->assertTrue(false);

    }

    /**
     * @depends test_create_object
     */
    public function test_update_categories()
    {

        $id = func_get_args();

        $min_count = false;

        $l_params = [
            'apikey'  => $this->m_apikey,
            'obj_id' => $id[0],
            'objects' => ["C__CATG__GLOBAL-title"=>"cate_title", "C__CATG__GLOBAL-id"=> $id[0]]
        ];

//        'objects' => ["C__CATG__GLOBAL-title"=>"cate_title", "C__CATG__GLOBAL-purpose"=>"5", "C__CATG__GLOBAL-cmdb_status"=> "Bestellt", "C__CATG__GLOBAL-category"=> "Andere", "C__CATG__GLOBAL-id"=> $id[0]]

        var_dump($l_params);

        $l_result = $this->m_client->__call('shd.categories.update', $l_params);

        var_dump($l_result);

        $i_check_Categorys = 0;


        $this->assertInternalType('array', $l_result);

        $this->assertEquals('categories.update.success', $l_result["message"]);

        return $id[0];
    }

    /**
     * @depends test_update_categories
     */
    public function test_read_categories()
    {
        //get ID from last Create
        $id = func_get_args();


        $l_params = [
            'session'     => $this->m_session,
            'id'          => '1',
            'apikey'      => $this->m_apikey,
            'condition'   => [["comparison" => "LIKE %...%", "property" => "C__CATG__GLOBAL-id", "category" => "C__CATG__GLOBAL", "value" => $id[0]]],
            'columns'     => [["id" => "C__CATG__GLOBAL-title", "width" => "140", "sort" => ""]],
            'obj_type_id' => '5'
        ];

        $l_result = $this->m_client->__call('shd.query.read', $l_params);

//        var_dump($l_result["content"]);

        $this->assertEquals('cate_title', $l_result["content"][$id[0]]["C__CATG__GLOBAL-title"]);

        //Time check
        if ((float)$l_result["time"] < 1) {
            $this->assertTrue(true);
        } else {
            print_r("Time check false");
            $this->assertTrue(false);
        }

        $this->assertInternalType('array', $l_result);


        return $id[0];
    }

    /**
     * @depends test_create_object
     */
    public function test_update_objects()
    {

        $id = func_get_args();

        $min_count = false;

        $l_params = [
            'apikey'  => $this->m_apikey,
            'objects' => ["C__CATG__GLOBAL-title"=>"objects_title", "C__CATG__GLOBAL-id"=> $id[0]]
        ];


        $l_result = $this->m_client->__call('shd.objects.update', $l_params);

        $i_check_Categorys = 0;

        $this->assertInternalType('array', $l_result);

        $this->assertEquals('objects.update.success', $l_result["message"]);

        return $id[0];
    }
//    public function test_update_objects()
//    {
//        global $g_test_config;
//
//        $l_params = [
//            'id'      => '1',
//            'apikey' => '365478025',
//            'with_dialog' => true
//        ];
//
//        $l_result = $this->m_client->__call('shd.properties', $l_params);
//
//        $i_check_Categorys = 0;
//
//        foreach ($l_result as $item) {
//            if($item["const"] == "C__CATG__GLOBAL") {
//                $i_check_Categorys += 1;
//            }
//        }
//
//
//        $this->assertInternalType('array', $l_result);
//
//        $this->assertEquals('objects.create.success', $l_result["message"]);
//
//        //there are 15 properties in Global
//
//    }

//    public function test_read_object_types()
//    {
//        $l_params = [
//            'session' => $this->m_session
//        ];
//
//        $l_result = $this->m_client->__call('cmdb.read.object_types', $l_params);
//
//        dump($l_result);
//
//        $this->assertInternalType('array', $l_result);
//    }
//
//    public function test_objects()
//    {
//        $l_params = [
//            'session' => $this->m_session,
//            'type'    => 1,
//            'limit'   => '0, 2',
//            'sort'    => 'DESC',
//            'raw'     => 'true'
//        ];
//
//        $l_result = $this->m_client->__call('cmdb.read.objects', $l_params);
//
//        dump($l_result);
//
//        $this->assertInternalType('array', $l_result);
//    }
//
//    public function test_object_by_types()
//    {
//        $l_params = [
//            'session' => $this->m_session
//        ];
//
//        $l_result = $this->m_client->__call('cmdb.read.object_by_types', $l_params);
//
//        dump($l_result);
//
//        $this->assertInternalType('array', $l_result);
//    }
//
//    public function test_read_categories_by_object_type()
//    {
//        $l_params = [
//            'session'  => $this->m_session,
//            'type'     => 1,
//            'raw'      => 'off',
//            'category' => 'specific'
//        ];
//
//        $l_result = $this->m_client->__call('cmdb.read.categories_by_object_type', $l_params);
//
//        dump($l_result);
//
//        $this->assertInternalType('array', $l_result);
//    }
//
//    public function test_read_objects_by_property()
//    {
//        $l_params = [
//            'session' => $this->m_session,
//            'type'    => 5,
//            'raw'     => 'off',
//            'limit'   => '2'
//        ];
//
//        $l_result = $this->m_client->__call('cmdb.read.objects_by_property', $l_params);
//
//        dump($l_result);
//
//        $this->assertInternalType('array', $l_result);
//    }
//
//    public function test_read_location_tree()
//    {
//        $l_params = [
//            'session' => $this->m_session,
//            'id'      => 1,
//            'raw'     => 'off'
//        ];
//
//        $l_result = $this->m_client->__call('cmdb.read.location_tree', $l_params);
//
//        dump($l_result);
//
//        $this->assertInternalType('array', $l_result);
//    }
//
//    /**
//     * Sets up the fixture, for example, opens a network connection.
//     * This method is called before a test is executed.
//     */
    protected function setUp() : void
    {
        global $g_test_config;

        // Login required:
        $this->m_session = $g_test_config['session'];

//        $l_url = $g_test_config['path']['url'] . 'https://mrh-sma.shd-online.de/i-doit/src/jsonrpc.php';

        $l_url = 'https://mrh-sma.shd-online.de/i-doit/src/jsonrpc.php';

        $l_debug = $g_test_config['debug']['var_dump'];

        $this->m_client = new isys_json_rpc($l_url, $l_debug);

        $this->m_client->setRPCAuth('admin', 'admin');

        $this->m_apikey = '365478025';
    }
//
//    /**
//     * Tears down the fixture, for example, closes a network connection.
//     * This method is called after a test is executed.
//     */
//    protected function tearDown()
//    {
//    }

}

?>
